/* contacts-avatar.c generated by valac 0.56.13, the Vala compiler
 * generated from contacts-avatar.vala, do not modify */

/*
 * Copyright (C) 2011 Alexander Larsson <alexl@redhat.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <folks/folks.h>
#include "contactscore.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <gee.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CONTACTS_TYPE_AVATAR (contacts_avatar_get_type ())
#define CONTACTS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_AVATAR, ContactsAvatar))
#define CONTACTS_AVATAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_AVATAR, ContactsAvatarClass))
#define CONTACTS_IS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_AVATAR))
#define CONTACTS_IS_AVATAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_AVATAR))
#define CONTACTS_AVATAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_AVATAR, ContactsAvatarClass))

typedef struct _ContactsAvatar ContactsAvatar;
typedef struct _ContactsAvatarClass ContactsAvatarClass;
typedef struct _ContactsAvatarPrivate ContactsAvatarPrivate;
enum  {
	CONTACTS_AVATAR_0_PROPERTY,
	CONTACTS_AVATAR_INDIVIDUAL_PROPERTY,
	CONTACTS_AVATAR_CONTACT_PROPERTY,
	CONTACTS_AVATAR_AVATAR_SIZE_PROPERTY,
	CONTACTS_AVATAR_NUM_PROPERTIES
};
static GParamSpec* contacts_avatar_properties[CONTACTS_AVATAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block9Data Block9Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ContactsAvatarLoadAvatarData ContactsAvatarLoadAvatarData;

struct _ContactsAvatar {
	AdwBin parent_instance;
	ContactsAvatarPrivate * priv;
};

struct _ContactsAvatarClass {
	AdwBinClass parent_class;
};

struct _ContactsAvatarPrivate {
	FolksIndividual* _individual;
	ContactsContact* _contact;
	gint _avatar_size;
};

struct _Block9Data {
	int _ref_count_;
	ContactsAvatar* self;
	ContactsAvatarChunk* avatar_chunk;
};

struct _ContactsAvatarLoadAvatarData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ContactsAvatar* self;
	GLoadableIcon* icon;
	GInputStream* stream;
	gint _tmp0_;
	GInputStream* _tmp1_;
	GdkPixbuf* pixbuf;
	GInputStream* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* _tmp6_;
	GError* e;
	FolksIndividual* _tmp7_;
	FolksIndividual* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GError* _inner_error0_;
};

static gint ContactsAvatar_private_offset;
static gpointer contacts_avatar_parent_class = NULL;

VALA_EXTERN GType contacts_avatar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsAvatar, g_object_unref)
VALA_EXTERN ContactsAvatar* contacts_avatar_new (gint size,
                                     FolksIndividual* individual);
VALA_EXTERN ContactsAvatar* contacts_avatar_construct (GType object_type,
                                           gint size,
                                           FolksIndividual* individual);
VALA_EXTERN ContactsAvatar* contacts_avatar_new_for_contact (gint size,
                                                 ContactsContact* contact);
VALA_EXTERN ContactsAvatar* contacts_avatar_construct_for_contact (GType object_type,
                                                       gint size,
                                                       ContactsContact* contact);
static void contacts_avatar_update_individual (ContactsAvatar* self);
VALA_EXTERN ContactsContact* contacts_avatar_get_contact (ContactsAvatar* self);
VALA_EXTERN FolksIndividual* contacts_avatar_get_individual (ContactsAvatar* self);
static gchar* contacts_avatar_find_display_name (ContactsAvatar* self);
static void contacts_avatar_load_avatar (ContactsAvatar* self,
                                  GLoadableIcon* icon,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
static void contacts_avatar_load_avatar_finish (ContactsAvatar* self,
                                         GAsyncResult* _res_);
static void contacts_avatar_update_contact (ContactsAvatar* self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda7_ (Block9Data* _data9_,
                 GObject* obj,
                 GParamSpec* pspec);
static void ___lambda7__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void contacts_avatar_load_avatar_data_free (gpointer _data);
static gboolean contacts_avatar_load_avatar_co (ContactsAvatarLoadAvatarData* _data_);
VALA_EXTERN void contacts_avatar_set_pixbuf (ContactsAvatar* self,
                                 GdkPixbuf* a_pixbuf);
VALA_EXTERN gint contacts_avatar_get_avatar_size (ContactsAvatar* self);
static void contacts_avatar_load_avatar_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_);
static const gchar* contacts_avatar_look_up_alias_for_display_name (ContactsAvatar* self,
                                                             FolksPersona* p);
static gchar* contacts_avatar_look_up_name_details_for_display_name (ContactsAvatar* self,
                                                              FolksPersona* p);
VALA_EXTERN void contacts_avatar_set_individual (ContactsAvatar* self,
                                     FolksIndividual* value);
VALA_EXTERN void contacts_avatar_set_contact (ContactsAvatar* self,
                                  ContactsContact* value);
VALA_EXTERN void contacts_avatar_set_avatar_size (ContactsAvatar* self,
                                      gint value);
static GObject * contacts_avatar_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void contacts_avatar_finalize (GObject * obj);
static GType contacts_avatar_get_type_once (void);
static void _vala_contacts_avatar_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_contacts_avatar_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
contacts_avatar_get_instance_private (ContactsAvatar* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsAvatar_private_offset);
}

ContactsAvatar*
contacts_avatar_construct (GType object_type,
                           gint size,
                           FolksIndividual* individual)
{
	ContactsAvatar * self = NULL;
#line 58 "../src/contacts-avatar.vala"
	self = (ContactsAvatar*) g_object_new (object_type, "avatar-size", size, "individual", individual, NULL);
#line 57 "../src/contacts-avatar.vala"
	return self;
#line 198 "contacts-avatar.c"
}

ContactsAvatar*
contacts_avatar_new (gint size,
                     FolksIndividual* individual)
{
#line 57 "../src/contacts-avatar.vala"
	return contacts_avatar_construct (CONTACTS_TYPE_AVATAR, size, individual);
#line 207 "contacts-avatar.c"
}

ContactsAvatar*
contacts_avatar_construct_for_contact (GType object_type,
                                       gint size,
                                       ContactsContact* contact)
{
	ContactsAvatar * self = NULL;
#line 61 "../src/contacts-avatar.vala"
	g_return_val_if_fail (contact != NULL, NULL);
#line 62 "../src/contacts-avatar.vala"
	self = (ContactsAvatar*) g_object_new (object_type, "avatar-size", size, "contact", contact, NULL);
#line 61 "../src/contacts-avatar.vala"
	return self;
#line 222 "contacts-avatar.c"
}

ContactsAvatar*
contacts_avatar_new_for_contact (gint size,
                                 ContactsContact* contact)
{
#line 61 "../src/contacts-avatar.vala"
	return contacts_avatar_construct_for_contact (CONTACTS_TYPE_AVATAR, size, contact);
#line 231 "contacts-avatar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 85 "../src/contacts-avatar.vala"
	return self ? g_object_ref (self) : NULL;
#line 239 "contacts-avatar.c"
}

static void
contacts_avatar_update_individual (ContactsAvatar* self)
{
	ContactsContact* _tmp0_;
	ContactsContact* _tmp1_;
	gchar* name = NULL;
	gchar* _tmp2_;
	gboolean show_initials = FALSE;
	FolksIndividual* _tmp3_;
	FolksIndividual* _tmp4_;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkWidget* _tmp14_;
	GtkWidget* _tmp15_;
	const gchar* _tmp16_;
	GLoadableIcon* _tmp17_ = NULL;
	FolksIndividual* _tmp18_;
	FolksIndividual* _tmp19_;
	GLoadableIcon* icon = NULL;
	GLoadableIcon* _tmp24_;
	GLoadableIcon* _tmp25_;
#line 65 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/contacts-avatar.vala"
	_tmp0_ = contacts_avatar_get_contact (self);
#line 66 "../src/contacts-avatar.vala"
	_tmp1_ = _tmp0_;
#line 66 "../src/contacts-avatar.vala"
	if (_tmp1_ != NULL) {
#line 67 "../src/contacts-avatar.vala"
		return;
#line 273 "contacts-avatar.c"
	}
#line 69 "../src/contacts-avatar.vala"
	_tmp2_ = g_strdup ("");
#line 69 "../src/contacts-avatar.vala"
	name = _tmp2_;
#line 70 "../src/contacts-avatar.vala"
	show_initials = FALSE;
#line 71 "../src/contacts-avatar.vala"
	_tmp3_ = contacts_avatar_get_individual (self);
#line 71 "../src/contacts-avatar.vala"
	_tmp4_ = _tmp3_;
#line 71 "../src/contacts-avatar.vala"
	if (_tmp4_ != NULL) {
#line 287 "contacts-avatar.c"
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 72 "../src/contacts-avatar.vala"
		_tmp5_ = contacts_avatar_find_display_name (self);
#line 72 "../src/contacts-avatar.vala"
		_g_free0 (name);
#line 72 "../src/contacts-avatar.vala"
		name = _tmp5_;
#line 75 "../src/contacts-avatar.vala"
		_tmp6_ = name;
#line 75 "../src/contacts-avatar.vala"
		if (g_strcmp0 (_tmp6_, "") == 0) {
#line 300 "contacts-avatar.c"
			FolksIndividual* _tmp7_;
			FolksIndividual* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 76 "../src/contacts-avatar.vala"
			_tmp7_ = contacts_avatar_get_individual (self);
#line 76 "../src/contacts-avatar.vala"
			_tmp8_ = _tmp7_;
#line 76 "../src/contacts-avatar.vala"
			_tmp9_ = folks_individual_get_display_name (_tmp8_);
#line 76 "../src/contacts-avatar.vala"
			_tmp10_ = _tmp9_;
#line 76 "../src/contacts-avatar.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 76 "../src/contacts-avatar.vala"
			_g_free0 (name);
#line 76 "../src/contacts-avatar.vala"
			name = _tmp11_;
#line 320 "contacts-avatar.c"
		} else {
#line 78 "../src/contacts-avatar.vala"
			show_initials = TRUE;
#line 324 "contacts-avatar.c"
		}
	}
#line 82 "../src/contacts-avatar.vala"
	_tmp12_ = adw_bin_get_child ((AdwBin*) self);
#line 82 "../src/contacts-avatar.vala"
	_tmp13_ = _tmp12_;
#line 82 "../src/contacts-avatar.vala"
	adw_avatar_set_show_initials (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, adw_avatar_get_type (), AdwAvatar), show_initials);
#line 83 "../src/contacts-avatar.vala"
	_tmp14_ = adw_bin_get_child ((AdwBin*) self);
#line 83 "../src/contacts-avatar.vala"
	_tmp15_ = _tmp14_;
#line 83 "../src/contacts-avatar.vala"
	_tmp16_ = name;
#line 83 "../src/contacts-avatar.vala"
	adw_avatar_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, adw_avatar_get_type (), AdwAvatar), _tmp16_);
#line 85 "../src/contacts-avatar.vala"
	_tmp18_ = contacts_avatar_get_individual (self);
#line 85 "../src/contacts-avatar.vala"
	_tmp19_ = _tmp18_;
#line 85 "../src/contacts-avatar.vala"
	if (_tmp19_ != NULL) {
#line 347 "contacts-avatar.c"
		FolksIndividual* _tmp20_;
		FolksIndividual* _tmp21_;
		GLoadableIcon* _tmp22_;
		GLoadableIcon* _tmp23_;
#line 85 "../src/contacts-avatar.vala"
		_tmp20_ = contacts_avatar_get_individual (self);
#line 85 "../src/contacts-avatar.vala"
		_tmp21_ = _tmp20_;
#line 85 "../src/contacts-avatar.vala"
		_tmp22_ = folks_avatar_details_get_avatar ((FolksAvatarDetails*) _tmp21_);
#line 85 "../src/contacts-avatar.vala"
		_tmp23_ = _tmp22_;
#line 85 "../src/contacts-avatar.vala"
		_tmp17_ = _tmp23_;
#line 362 "contacts-avatar.c"
	} else {
#line 85 "../src/contacts-avatar.vala"
		_tmp17_ = NULL;
#line 366 "contacts-avatar.c"
	}
#line 85 "../src/contacts-avatar.vala"
	_tmp24_ = _g_object_ref0 (_tmp17_);
#line 85 "../src/contacts-avatar.vala"
	icon = _tmp24_;
#line 86 "../src/contacts-avatar.vala"
	_tmp25_ = icon;
#line 86 "../src/contacts-avatar.vala"
	contacts_avatar_load_avatar (self, _tmp25_, NULL, NULL);
#line 65 "../src/contacts-avatar.vala"
	_g_object_unref0 (icon);
#line 65 "../src/contacts-avatar.vala"
	_g_free0 (name);
#line 380 "contacts-avatar.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 89 "../src/contacts-avatar.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 89 "../src/contacts-avatar.vala"
	return _data9_;
#line 390 "contacts-avatar.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 89 "../src/contacts-avatar.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 400 "contacts-avatar.c"
		ContactsAvatar* self;
#line 89 "../src/contacts-avatar.vala"
		self = _data9_->self;
#line 89 "../src/contacts-avatar.vala"
		_g_object_unref0 (self);
#line 89 "../src/contacts-avatar.vala"
		g_slice_free (Block9Data, _data9_);
#line 408 "contacts-avatar.c"
	}
}

static void
__lambda7_ (Block9Data* _data9_,
            GObject* obj,
            GParamSpec* pspec)
{
	ContactsAvatar* self;
	ContactsAvatarChunk* _tmp0_;
	GLoadableIcon* _tmp1_;
	GLoadableIcon* _tmp2_;
#line 112 "../src/contacts-avatar.vala"
	self = _data9_->self;
#line 112 "../src/contacts-avatar.vala"
	g_return_if_fail (obj != NULL);
#line 112 "../src/contacts-avatar.vala"
	g_return_if_fail (pspec != NULL);
#line 113 "../src/contacts-avatar.vala"
	_tmp0_ = _data9_->avatar_chunk;
#line 113 "../src/contacts-avatar.vala"
	_tmp1_ = contacts_avatar_chunk_get_avatar (_tmp0_);
#line 113 "../src/contacts-avatar.vala"
	_tmp2_ = _tmp1_;
#line 113 "../src/contacts-avatar.vala"
	contacts_avatar_load_avatar (self, _tmp2_, NULL, NULL);
#line 435 "contacts-avatar.c"
}

static void
___lambda7__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 112 "../src/contacts-avatar.vala"
	__lambda7_ (self, _sender, pspec);
#line 445 "contacts-avatar.c"
}

static void
contacts_avatar_update_contact (ContactsAvatar* self)
{
	Block9Data* _data9_;
	FolksIndividual* _tmp0_;
	FolksIndividual* _tmp1_;
	gchar* name = NULL;
	gchar* _tmp2_;
	gboolean show_initials = FALSE;
	ContactsContact* _tmp3_;
	ContactsContact* _tmp4_;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkWidget* _tmp14_;
	GtkWidget* _tmp15_;
	const gchar* _tmp16_;
	ContactsChunk* chunk = NULL;
	ContactsContact* _tmp17_;
	ContactsContact* _tmp18_;
	ContactsChunk* _tmp19_;
	ContactsChunk* _tmp20_;
	ContactsChunk* _tmp21_;
	ContactsChunk* _tmp26_;
	ContactsAvatarChunk* _tmp27_;
	ContactsAvatarChunk* _tmp28_;
	GLoadableIcon* _tmp29_;
	GLoadableIcon* _tmp30_;
#line 89 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/contacts-avatar.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 89 "../src/contacts-avatar.vala"
	_data9_->_ref_count_ = 1;
#line 89 "../src/contacts-avatar.vala"
	_data9_->self = g_object_ref (self);
#line 90 "../src/contacts-avatar.vala"
	_tmp0_ = contacts_avatar_get_individual (self);
#line 90 "../src/contacts-avatar.vala"
	_tmp1_ = _tmp0_;
#line 90 "../src/contacts-avatar.vala"
	if (_tmp1_ != NULL) {
#line 91 "../src/contacts-avatar.vala"
		block9_data_unref (_data9_);
#line 91 "../src/contacts-avatar.vala"
		_data9_ = NULL;
#line 91 "../src/contacts-avatar.vala"
		return;
#line 495 "contacts-avatar.c"
	}
#line 93 "../src/contacts-avatar.vala"
	_tmp2_ = g_strdup ("");
#line 93 "../src/contacts-avatar.vala"
	name = _tmp2_;
#line 94 "../src/contacts-avatar.vala"
	show_initials = FALSE;
#line 95 "../src/contacts-avatar.vala"
	_tmp3_ = contacts_avatar_get_contact (self);
#line 95 "../src/contacts-avatar.vala"
	_tmp4_ = _tmp3_;
#line 95 "../src/contacts-avatar.vala"
	if (_tmp4_ != NULL) {
#line 509 "contacts-avatar.c"
		ContactsContact* _tmp5_;
		ContactsContact* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
#line 96 "../src/contacts-avatar.vala"
		_tmp5_ = contacts_avatar_get_contact (self);
#line 96 "../src/contacts-avatar.vala"
		_tmp6_ = _tmp5_;
#line 96 "../src/contacts-avatar.vala"
		_tmp7_ = contacts_contact_fetch_name (_tmp6_);
#line 96 "../src/contacts-avatar.vala"
		_g_free0 (name);
#line 96 "../src/contacts-avatar.vala"
		name = _tmp7_;
#line 99 "../src/contacts-avatar.vala"
		_tmp8_ = name;
#line 99 "../src/contacts-avatar.vala"
		if (_tmp8_ == NULL) {
#line 528 "contacts-avatar.c"
			ContactsContact* _tmp9_;
			ContactsContact* _tmp10_;
			gchar* _tmp11_;
#line 100 "../src/contacts-avatar.vala"
			_tmp9_ = contacts_avatar_get_contact (self);
#line 100 "../src/contacts-avatar.vala"
			_tmp10_ = _tmp9_;
#line 100 "../src/contacts-avatar.vala"
			_tmp11_ = contacts_contact_fetch_display_name (_tmp10_);
#line 100 "../src/contacts-avatar.vala"
			_g_free0 (name);
#line 100 "../src/contacts-avatar.vala"
			name = _tmp11_;
#line 542 "contacts-avatar.c"
		} else {
#line 102 "../src/contacts-avatar.vala"
			show_initials = TRUE;
#line 546 "contacts-avatar.c"
		}
	}
#line 105 "../src/contacts-avatar.vala"
	_tmp12_ = adw_bin_get_child ((AdwBin*) self);
#line 105 "../src/contacts-avatar.vala"
	_tmp13_ = _tmp12_;
#line 105 "../src/contacts-avatar.vala"
	adw_avatar_set_show_initials (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, adw_avatar_get_type (), AdwAvatar), show_initials);
#line 106 "../src/contacts-avatar.vala"
	_tmp14_ = adw_bin_get_child ((AdwBin*) self);
#line 106 "../src/contacts-avatar.vala"
	_tmp15_ = _tmp14_;
#line 106 "../src/contacts-avatar.vala"
	_tmp16_ = name;
#line 106 "../src/contacts-avatar.vala"
	adw_avatar_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, adw_avatar_get_type (), AdwAvatar), _tmp16_);
#line 108 "../src/contacts-avatar.vala"
	_tmp17_ = contacts_avatar_get_contact (self);
#line 108 "../src/contacts-avatar.vala"
	_tmp18_ = _tmp17_;
#line 108 "../src/contacts-avatar.vala"
	_tmp19_ = contacts_contact_get_most_relevant_chunk (_tmp18_, "avatar", TRUE);
#line 108 "../src/contacts-avatar.vala"
	_tmp20_ = _g_object_ref0 (_tmp19_);
#line 108 "../src/contacts-avatar.vala"
	chunk = _tmp20_;
#line 109 "../src/contacts-avatar.vala"
	_tmp21_ = chunk;
#line 109 "../src/contacts-avatar.vala"
	if (_tmp21_ == NULL) {
#line 577 "contacts-avatar.c"
		ContactsContact* _tmp22_;
		ContactsContact* _tmp23_;
		ContactsChunk* _tmp24_;
		ContactsChunk* _tmp25_;
#line 110 "../src/contacts-avatar.vala"
		_tmp22_ = contacts_avatar_get_contact (self);
#line 110 "../src/contacts-avatar.vala"
		_tmp23_ = _tmp22_;
#line 110 "../src/contacts-avatar.vala"
		_tmp24_ = contacts_contact_create_chunk (_tmp23_, "avatar", NULL);
#line 110 "../src/contacts-avatar.vala"
		_tmp25_ = _g_object_ref0 (_tmp24_);
#line 110 "../src/contacts-avatar.vala"
		_g_object_unref0 (chunk);
#line 110 "../src/contacts-avatar.vala"
		chunk = _tmp25_;
#line 594 "contacts-avatar.c"
	}
#line 111 "../src/contacts-avatar.vala"
	_tmp26_ = chunk;
#line 111 "../src/contacts-avatar.vala"
	_data9_->avatar_chunk = G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, CONTACTS_TYPE_AVATAR_CHUNK, ContactsAvatarChunk);
#line 112 "../src/contacts-avatar.vala"
	_tmp27_ = _data9_->avatar_chunk;
#line 112 "../src/contacts-avatar.vala"
	g_signal_connect_data ((GObject*) _tmp27_, "notify::avatar", (GCallback) ___lambda7__g_object_notify, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 115 "../src/contacts-avatar.vala"
	_tmp28_ = _data9_->avatar_chunk;
#line 115 "../src/contacts-avatar.vala"
	_tmp29_ = contacts_avatar_chunk_get_avatar (_tmp28_);
#line 115 "../src/contacts-avatar.vala"
	_tmp30_ = _tmp29_;
#line 115 "../src/contacts-avatar.vala"
	contacts_avatar_load_avatar (self, _tmp30_, NULL, NULL);
#line 89 "../src/contacts-avatar.vala"
	_g_object_unref0 (chunk);
#line 89 "../src/contacts-avatar.vala"
	_g_free0 (name);
#line 89 "../src/contacts-avatar.vala"
	block9_data_unref (_data9_);
#line 89 "../src/contacts-avatar.vala"
	_data9_ = NULL;
#line 620 "contacts-avatar.c"
}

static void
contacts_avatar_load_avatar_data_free (gpointer _data)
{
	ContactsAvatarLoadAvatarData* _data_;
	_data_ = _data;
#line 24 "../src/contacts-avatar.vala"
	_g_object_unref0 (_data_->icon);
#line 24 "../src/contacts-avatar.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/contacts-avatar.vala"
	g_slice_free (ContactsAvatarLoadAvatarData, _data_);
#line 634 "contacts-avatar.c"
}

static void
contacts_avatar_load_avatar (ContactsAvatar* self,
                             GLoadableIcon* icon,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	ContactsAvatarLoadAvatarData* _data_;
	ContactsAvatar* _tmp0_;
	GLoadableIcon* _tmp1_;
#line 24 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/contacts-avatar.vala"
	_data_ = g_slice_new0 (ContactsAvatarLoadAvatarData);
#line 24 "../src/contacts-avatar.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 24 "../src/contacts-avatar.vala"
	g_task_set_task_data (_data_->_async_result, _data_, contacts_avatar_load_avatar_data_free);
#line 24 "../src/contacts-avatar.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/contacts-avatar.vala"
	_data_->self = _tmp0_;
#line 24 "../src/contacts-avatar.vala"
	_tmp1_ = _g_object_ref0 (icon);
#line 24 "../src/contacts-avatar.vala"
	_g_object_unref0 (_data_->icon);
#line 24 "../src/contacts-avatar.vala"
	_data_->icon = _tmp1_;
#line 24 "../src/contacts-avatar.vala"
	contacts_avatar_load_avatar_co (_data_);
#line 666 "contacts-avatar.c"
}

static void
contacts_avatar_load_avatar_finish (ContactsAvatar* self,
                                    GAsyncResult* _res_)
{
	ContactsAvatarLoadAvatarData* _data_;
#line 24 "../src/contacts-avatar.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 676 "contacts-avatar.c"
}

static void
contacts_avatar_load_avatar_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_)
{
	ContactsAvatarLoadAvatarData* _data_;
#line 125 "../src/contacts-avatar.vala"
	_data_ = _user_data_;
#line 125 "../src/contacts-avatar.vala"
	_data_->_source_object_ = source_object;
#line 125 "../src/contacts-avatar.vala"
	_data_->_res_ = _res_;
#line 125 "../src/contacts-avatar.vala"
	contacts_avatar_load_avatar_co (_data_);
#line 693 "contacts-avatar.c"
}

static gboolean
contacts_avatar_load_avatar_co (ContactsAvatarLoadAvatarData* _data_)
{
#line 118 "../src/contacts-avatar.vala"
	switch (_data_->_state_) {
#line 118 "../src/contacts-avatar.vala"
		case 0:
#line 703 "contacts-avatar.c"
		goto _state_0;
#line 118 "../src/contacts-avatar.vala"
		case 1:
#line 707 "contacts-avatar.c"
		goto _state_1;
#line 118 "../src/contacts-avatar.vala"
		case 2:
#line 711 "contacts-avatar.c"
		goto _state_2;
		default:
#line 118 "../src/contacts-avatar.vala"
		g_assert_not_reached ();
#line 716 "contacts-avatar.c"
	}
	_state_0:
#line 119 "../src/contacts-avatar.vala"
	if (_data_->icon == NULL) {
#line 120 "../src/contacts-avatar.vala"
		contacts_avatar_set_pixbuf (_data_->self, NULL);
#line 121 "../src/contacts-avatar.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 121 "../src/contacts-avatar.vala"
		if (_data_->_state_ != 0) {
#line 121 "../src/contacts-avatar.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 121 "../src/contacts-avatar.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 731 "contacts-avatar.c"
			}
		}
#line 121 "../src/contacts-avatar.vala"
		g_object_unref (_data_->_async_result);
#line 121 "../src/contacts-avatar.vala"
		return FALSE;
#line 738 "contacts-avatar.c"
	}
	{
#line 125 "../src/contacts-avatar.vala"
		_data_->_tmp0_ = _data_->self->priv->_avatar_size;
#line 125 "../src/contacts-avatar.vala"
		_data_->_state_ = 1;
#line 125 "../src/contacts-avatar.vala"
		g_loadable_icon_load_async (_data_->icon, _data_->_tmp0_, NULL, contacts_avatar_load_avatar_ready, _data_);
#line 125 "../src/contacts-avatar.vala"
		return FALSE;
#line 749 "contacts-avatar.c"
		_state_1:
#line 125 "../src/contacts-avatar.vala"
		_data_->_tmp1_ = g_loadable_icon_load_finish (_data_->icon, _data_->_res_, NULL, &_data_->_inner_error0_);
#line 125 "../src/contacts-avatar.vala"
		_data_->stream = _data_->_tmp1_;
#line 125 "../src/contacts-avatar.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 757 "contacts-avatar.c"
			goto __catch0_g_error;
		}
#line 126 "../src/contacts-avatar.vala"
		_data_->_tmp2_ = _data_->stream;
#line 126 "../src/contacts-avatar.vala"
		_data_->_tmp3_ = _data_->self->priv->_avatar_size;
#line 126 "../src/contacts-avatar.vala"
		_data_->_tmp4_ = _data_->self->priv->_avatar_size;
#line 126 "../src/contacts-avatar.vala"
		_data_->_state_ = 2;
#line 126 "../src/contacts-avatar.vala"
		gdk_pixbuf_new_from_stream_at_scale_async (_data_->_tmp2_, _data_->_tmp3_, _data_->_tmp4_, TRUE, NULL, contacts_avatar_load_avatar_ready, _data_);
#line 126 "../src/contacts-avatar.vala"
		return FALSE;
#line 772 "contacts-avatar.c"
		_state_2:
#line 126 "../src/contacts-avatar.vala"
		_data_->_tmp5_ = (GdkPixbuf*) gdk_pixbuf_new_from_stream_finish (_data_->_res_, &_data_->_inner_error0_);
#line 126 "../src/contacts-avatar.vala"
		_data_->pixbuf = _data_->_tmp5_;
#line 126 "../src/contacts-avatar.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 126 "../src/contacts-avatar.vala"
			_g_object_unref0 (_data_->stream);
#line 782 "contacts-avatar.c"
			goto __catch0_g_error;
		}
#line 130 "../src/contacts-avatar.vala"
		_data_->_tmp6_ = _data_->pixbuf;
#line 130 "../src/contacts-avatar.vala"
		contacts_avatar_set_pixbuf (_data_->self, _data_->_tmp6_);
#line 124 "../src/contacts-avatar.vala"
		_g_object_unref0 (_data_->pixbuf);
#line 124 "../src/contacts-avatar.vala"
		_g_object_unref0 (_data_->stream);
#line 793 "contacts-avatar.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 124 "../src/contacts-avatar.vala"
		_data_->e = _data_->_inner_error0_;
#line 124 "../src/contacts-avatar.vala"
		_data_->_inner_error0_ = NULL;
#line 132 "../src/contacts-avatar.vala"
		_data_->_tmp7_ = contacts_avatar_get_individual (_data_->self);
#line 132 "../src/contacts-avatar.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 132 "../src/contacts-avatar.vala"
		_data_->_tmp9_ = folks_individual_get_display_name (_data_->_tmp8_);
#line 132 "../src/contacts-avatar.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 132 "../src/contacts-avatar.vala"
		_data_->_tmp11_ = _data_->e;
#line 132 "../src/contacts-avatar.vala"
		_data_->_tmp12_ = _data_->_tmp11_->message;
#line 132 "../src/contacts-avatar.vala"
		g_warning ("contacts-avatar.vala:132: Couldn't load avatar of '%s': %s", _data_->_tmp10_, _data_->_tmp12_);
#line 124 "../src/contacts-avatar.vala"
		_g_error_free0 (_data_->e);
#line 818 "contacts-avatar.c"
	}
	__finally0:
#line 124 "../src/contacts-avatar.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 124 "../src/contacts-avatar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 124 "../src/contacts-avatar.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 124 "../src/contacts-avatar.vala"
		g_object_unref (_data_->_async_result);
#line 124 "../src/contacts-avatar.vala"
		return FALSE;
#line 831 "contacts-avatar.c"
	}
#line 118 "../src/contacts-avatar.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 118 "../src/contacts-avatar.vala"
	if (_data_->_state_ != 0) {
#line 118 "../src/contacts-avatar.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 118 "../src/contacts-avatar.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 841 "contacts-avatar.c"
		}
	}
#line 118 "../src/contacts-avatar.vala"
	g_object_unref (_data_->_async_result);
#line 118 "../src/contacts-avatar.vala"
	return FALSE;
#line 848 "contacts-avatar.c"
}

/**
   * Manually set the avatar to the given pixbuf, even if the contact has an avatar.
   */
void
contacts_avatar_set_pixbuf (ContactsAvatar* self,
                            GdkPixbuf* a_pixbuf)
{
	GdkTexture* _tmp0_ = NULL;
	GdkTexture* img = NULL;
	GdkTexture* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
#line 139 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/contacts-avatar.vala"
	if (a_pixbuf != NULL) {
#line 867 "contacts-avatar.c"
		GdkTexture* _tmp1_;
#line 140 "../src/contacts-avatar.vala"
		_tmp1_ = gdk_texture_new_for_pixbuf (a_pixbuf);
#line 140 "../src/contacts-avatar.vala"
		_g_object_unref0 (_tmp0_);
#line 140 "../src/contacts-avatar.vala"
		_tmp0_ = _tmp1_;
#line 875 "contacts-avatar.c"
	} else {
#line 140 "../src/contacts-avatar.vala"
		_g_object_unref0 (_tmp0_);
#line 140 "../src/contacts-avatar.vala"
		_tmp0_ = NULL;
#line 881 "contacts-avatar.c"
	}
#line 140 "../src/contacts-avatar.vala"
	_tmp2_ = _g_object_ref0 (_tmp0_);
#line 140 "../src/contacts-avatar.vala"
	img = _tmp2_;
#line 141 "../src/contacts-avatar.vala"
	_tmp3_ = adw_bin_get_child ((AdwBin*) self);
#line 141 "../src/contacts-avatar.vala"
	_tmp4_ = _tmp3_;
#line 141 "../src/contacts-avatar.vala"
	adw_avatar_set_custom_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, adw_avatar_get_type (), AdwAvatar), (GdkPaintable*) img);
#line 139 "../src/contacts-avatar.vala"
	_g_object_unref0 (img);
#line 139 "../src/contacts-avatar.vala"
	_g_object_unref0 (_tmp0_);
#line 897 "contacts-avatar.c"
}

static gchar*
contacts_avatar_find_display_name (ContactsAvatar* self)
{
	FolksPersona* primary_persona = NULL;
	const gchar* alias = NULL;
	FolksPersona* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp43_;
	gchar* result;
#line 148 "../src/contacts-avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 149 "../src/contacts-avatar.vala"
	primary_persona = NULL;
#line 914 "contacts-avatar.c"
	{
		GeeIterator* _p_it = NULL;
		FolksIndividual* _tmp0_;
		FolksIndividual* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
#line 150 "../src/contacts-avatar.vala"
		_tmp0_ = contacts_avatar_get_individual (self);
#line 150 "../src/contacts-avatar.vala"
		_tmp1_ = _tmp0_;
#line 150 "../src/contacts-avatar.vala"
		_tmp2_ = folks_individual_get_personas (_tmp1_);
#line 150 "../src/contacts-avatar.vala"
		_tmp3_ = _tmp2_;
#line 150 "../src/contacts-avatar.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 150 "../src/contacts-avatar.vala"
		_p_it = _tmp4_;
#line 150 "../src/contacts-avatar.vala"
		while (TRUE) {
#line 936 "contacts-avatar.c"
			GeeIterator* _tmp5_;
			FolksPersona* p = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			FolksPersona* _tmp8_;
			FolksPersonaStore* _tmp9_;
			FolksPersonaStore* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 150 "../src/contacts-avatar.vala"
			_tmp5_ = _p_it;
#line 150 "../src/contacts-avatar.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 150 "../src/contacts-avatar.vala"
				break;
#line 952 "contacts-avatar.c"
			}
#line 150 "../src/contacts-avatar.vala"
			_tmp6_ = _p_it;
#line 150 "../src/contacts-avatar.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 150 "../src/contacts-avatar.vala"
			p = (FolksPersona*) _tmp7_;
#line 151 "../src/contacts-avatar.vala"
			_tmp8_ = p;
#line 151 "../src/contacts-avatar.vala"
			_tmp9_ = folks_persona_get_store (_tmp8_);
#line 151 "../src/contacts-avatar.vala"
			_tmp10_ = _tmp9_;
#line 151 "../src/contacts-avatar.vala"
			_tmp11_ = folks_persona_store_get_is_primary_store (_tmp10_);
#line 151 "../src/contacts-avatar.vala"
			_tmp12_ = _tmp11_;
#line 151 "../src/contacts-avatar.vala"
			if (_tmp12_) {
#line 972 "contacts-avatar.c"
				FolksPersona* _tmp13_;
#line 152 "../src/contacts-avatar.vala"
				_tmp13_ = p;
#line 152 "../src/contacts-avatar.vala"
				primary_persona = _tmp13_;
#line 153 "../src/contacts-avatar.vala"
				_g_object_unref0 (p);
#line 153 "../src/contacts-avatar.vala"
				break;
#line 982 "contacts-avatar.c"
			}
#line 150 "../src/contacts-avatar.vala"
			_g_object_unref0 (p);
#line 986 "contacts-avatar.c"
		}
#line 150 "../src/contacts-avatar.vala"
		_g_object_unref0 (_p_it);
#line 990 "contacts-avatar.c"
	}
#line 157 "../src/contacts-avatar.vala"
	_tmp14_ = primary_persona;
#line 157 "../src/contacts-avatar.vala"
	_tmp15_ = contacts_avatar_look_up_alias_for_display_name (self, _tmp14_);
#line 157 "../src/contacts-avatar.vala"
	alias = _tmp15_;
#line 158 "../src/contacts-avatar.vala"
	_tmp16_ = alias;
#line 158 "../src/contacts-avatar.vala"
	if (g_strcmp0 (_tmp16_, "") != 0) {
#line 1002 "contacts-avatar.c"
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 159 "../src/contacts-avatar.vala"
		_tmp17_ = alias;
#line 159 "../src/contacts-avatar.vala"
		_tmp18_ = g_strdup (_tmp17_);
#line 159 "../src/contacts-avatar.vala"
		result = _tmp18_;
#line 159 "../src/contacts-avatar.vala"
		return result;
#line 1013 "contacts-avatar.c"
	}
	{
		GeeIterator* _p_it = NULL;
		FolksIndividual* _tmp19_;
		FolksIndividual* _tmp20_;
		GeeSet* _tmp21_;
		GeeSet* _tmp22_;
		GeeIterator* _tmp23_;
#line 161 "../src/contacts-avatar.vala"
		_tmp19_ = contacts_avatar_get_individual (self);
#line 161 "../src/contacts-avatar.vala"
		_tmp20_ = _tmp19_;
#line 161 "../src/contacts-avatar.vala"
		_tmp21_ = folks_individual_get_personas (_tmp20_);
#line 161 "../src/contacts-avatar.vala"
		_tmp22_ = _tmp21_;
#line 161 "../src/contacts-avatar.vala"
		_tmp23_ = gee_iterable_iterator ((GeeIterable*) _tmp22_);
#line 161 "../src/contacts-avatar.vala"
		_p_it = _tmp23_;
#line 161 "../src/contacts-avatar.vala"
		while (TRUE) {
#line 1036 "contacts-avatar.c"
			GeeIterator* _tmp24_;
			FolksPersona* p = NULL;
			GeeIterator* _tmp25_;
			gpointer _tmp26_;
			FolksPersona* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
#line 161 "../src/contacts-avatar.vala"
			_tmp24_ = _p_it;
#line 161 "../src/contacts-avatar.vala"
			if (!gee_iterator_next (_tmp24_)) {
#line 161 "../src/contacts-avatar.vala"
				break;
#line 1050 "contacts-avatar.c"
			}
#line 161 "../src/contacts-avatar.vala"
			_tmp25_ = _p_it;
#line 161 "../src/contacts-avatar.vala"
			_tmp26_ = gee_iterator_get (_tmp25_);
#line 161 "../src/contacts-avatar.vala"
			p = (FolksPersona*) _tmp26_;
#line 162 "../src/contacts-avatar.vala"
			_tmp27_ = p;
#line 162 "../src/contacts-avatar.vala"
			_tmp28_ = contacts_avatar_look_up_alias_for_display_name (self, _tmp27_);
#line 162 "../src/contacts-avatar.vala"
			alias = _tmp28_;
#line 163 "../src/contacts-avatar.vala"
			_tmp29_ = alias;
#line 163 "../src/contacts-avatar.vala"
			if (g_strcmp0 (_tmp29_, "") != 0) {
#line 1068 "contacts-avatar.c"
				const gchar* _tmp30_;
				gchar* _tmp31_;
#line 164 "../src/contacts-avatar.vala"
				_tmp30_ = alias;
#line 164 "../src/contacts-avatar.vala"
				_tmp31_ = g_strdup (_tmp30_);
#line 164 "../src/contacts-avatar.vala"
				result = _tmp31_;
#line 164 "../src/contacts-avatar.vala"
				_g_object_unref0 (p);
#line 164 "../src/contacts-avatar.vala"
				_g_object_unref0 (_p_it);
#line 164 "../src/contacts-avatar.vala"
				return result;
#line 1083 "contacts-avatar.c"
			}
#line 161 "../src/contacts-avatar.vala"
			_g_object_unref0 (p);
#line 1087 "contacts-avatar.c"
		}
#line 161 "../src/contacts-avatar.vala"
		_g_object_unref0 (_p_it);
#line 1091 "contacts-avatar.c"
	}
	{
		GeeIterator* _p_it = NULL;
		FolksIndividual* _tmp32_;
		FolksIndividual* _tmp33_;
		GeeSet* _tmp34_;
		GeeSet* _tmp35_;
		GeeIterator* _tmp36_;
#line 167 "../src/contacts-avatar.vala"
		_tmp32_ = contacts_avatar_get_individual (self);
#line 167 "../src/contacts-avatar.vala"
		_tmp33_ = _tmp32_;
#line 167 "../src/contacts-avatar.vala"
		_tmp34_ = folks_individual_get_personas (_tmp33_);
#line 167 "../src/contacts-avatar.vala"
		_tmp35_ = _tmp34_;
#line 167 "../src/contacts-avatar.vala"
		_tmp36_ = gee_iterable_iterator ((GeeIterable*) _tmp35_);
#line 167 "../src/contacts-avatar.vala"
		_p_it = _tmp36_;
#line 167 "../src/contacts-avatar.vala"
		while (TRUE) {
#line 1114 "contacts-avatar.c"
			GeeIterator* _tmp37_;
			FolksPersona* p = NULL;
			GeeIterator* _tmp38_;
			gpointer _tmp39_;
			gchar* name = NULL;
			FolksPersona* _tmp40_;
			gchar* _tmp41_;
			const gchar* _tmp42_;
#line 167 "../src/contacts-avatar.vala"
			_tmp37_ = _p_it;
#line 167 "../src/contacts-avatar.vala"
			if (!gee_iterator_next (_tmp37_)) {
#line 167 "../src/contacts-avatar.vala"
				break;
#line 1129 "contacts-avatar.c"
			}
#line 167 "../src/contacts-avatar.vala"
			_tmp38_ = _p_it;
#line 167 "../src/contacts-avatar.vala"
			_tmp39_ = gee_iterator_get (_tmp38_);
#line 167 "../src/contacts-avatar.vala"
			p = (FolksPersona*) _tmp39_;
#line 168 "../src/contacts-avatar.vala"
			_tmp40_ = p;
#line 168 "../src/contacts-avatar.vala"
			_tmp41_ = contacts_avatar_look_up_name_details_for_display_name (self, _tmp40_);
#line 168 "../src/contacts-avatar.vala"
			name = _tmp41_;
#line 169 "../src/contacts-avatar.vala"
			_tmp42_ = name;
#line 169 "../src/contacts-avatar.vala"
			if (g_strcmp0 (_tmp42_, "") != 0) {
#line 170 "../src/contacts-avatar.vala"
				result = name;
#line 170 "../src/contacts-avatar.vala"
				_g_object_unref0 (p);
#line 170 "../src/contacts-avatar.vala"
				_g_object_unref0 (_p_it);
#line 170 "../src/contacts-avatar.vala"
				return result;
#line 1155 "contacts-avatar.c"
			}
#line 167 "../src/contacts-avatar.vala"
			_g_free0 (name);
#line 167 "../src/contacts-avatar.vala"
			_g_object_unref0 (p);
#line 1161 "contacts-avatar.c"
		}
#line 167 "../src/contacts-avatar.vala"
		_g_object_unref0 (_p_it);
#line 1165 "contacts-avatar.c"
	}
#line 172 "../src/contacts-avatar.vala"
	_tmp43_ = g_strdup ("");
#line 172 "../src/contacts-avatar.vala"
	result = _tmp43_;
#line 172 "../src/contacts-avatar.vala"
	return result;
#line 1173 "contacts-avatar.c"
}

static const gchar*
contacts_avatar_look_up_alias_for_display_name (ContactsAvatar* self,
                                                FolksPersona* p)
{
	FolksAliasDetails* a = NULL;
	gboolean _tmp0_ = FALSE;
	FolksAliasDetails* _tmp1_;
	const gchar* result;
#line 175 "../src/contacts-avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 176 "../src/contacts-avatar.vala"
	a = G_TYPE_CHECK_INSTANCE_TYPE (p, FOLKS_TYPE_ALIAS_DETAILS) ? ((FolksAliasDetails*) p) : NULL;
#line 177 "../src/contacts-avatar.vala"
	_tmp1_ = a;
#line 177 "../src/contacts-avatar.vala"
	if (_tmp1_ != NULL) {
#line 1192 "contacts-avatar.c"
		FolksAliasDetails* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 177 "../src/contacts-avatar.vala"
		_tmp2_ = a;
#line 177 "../src/contacts-avatar.vala"
		_tmp3_ = folks_alias_details_get_alias (_tmp2_);
#line 177 "../src/contacts-avatar.vala"
		_tmp4_ = _tmp3_;
#line 177 "../src/contacts-avatar.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 1204 "contacts-avatar.c"
	} else {
#line 177 "../src/contacts-avatar.vala"
		_tmp0_ = FALSE;
#line 1208 "contacts-avatar.c"
	}
#line 177 "../src/contacts-avatar.vala"
	if (_tmp0_) {
#line 1212 "contacts-avatar.c"
		FolksAliasDetails* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 178 "../src/contacts-avatar.vala"
		_tmp5_ = a;
#line 178 "../src/contacts-avatar.vala"
		_tmp6_ = folks_alias_details_get_alias (_tmp5_);
#line 178 "../src/contacts-avatar.vala"
		_tmp7_ = _tmp6_;
#line 178 "../src/contacts-avatar.vala"
		result = _tmp7_;
#line 178 "../src/contacts-avatar.vala"
		return result;
#line 1226 "contacts-avatar.c"
	}
#line 180 "../src/contacts-avatar.vala"
	result = "";
#line 180 "../src/contacts-avatar.vala"
	return result;
#line 1232 "contacts-avatar.c"
}

static gchar*
contacts_avatar_look_up_name_details_for_display_name (ContactsAvatar* self,
                                                       FolksPersona* p)
{
	FolksNameDetails* n = NULL;
	FolksNameDetails* _tmp0_;
	gchar* _tmp26_;
	gchar* result;
#line 183 "../src/contacts-avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 184 "../src/contacts-avatar.vala"
	n = G_TYPE_CHECK_INSTANCE_TYPE (p, FOLKS_TYPE_NAME_DETAILS) ? ((FolksNameDetails*) p) : NULL;
#line 185 "../src/contacts-avatar.vala"
	_tmp0_ = n;
#line 185 "../src/contacts-avatar.vala"
	if (_tmp0_ != NULL) {
#line 1251 "contacts-avatar.c"
		gboolean _tmp1_ = FALSE;
		FolksNameDetails* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 186 "../src/contacts-avatar.vala"
		_tmp2_ = n;
#line 186 "../src/contacts-avatar.vala"
		_tmp3_ = folks_name_details_get_full_name (_tmp2_);
#line 186 "../src/contacts-avatar.vala"
		_tmp4_ = _tmp3_;
#line 186 "../src/contacts-avatar.vala"
		if (_tmp4_ != NULL) {
#line 1264 "contacts-avatar.c"
			FolksNameDetails* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
#line 186 "../src/contacts-avatar.vala"
			_tmp5_ = n;
#line 186 "../src/contacts-avatar.vala"
			_tmp6_ = folks_name_details_get_full_name (_tmp5_);
#line 186 "../src/contacts-avatar.vala"
			_tmp7_ = _tmp6_;
#line 186 "../src/contacts-avatar.vala"
			_tmp1_ = g_strcmp0 (_tmp7_, "") != 0;
#line 1276 "contacts-avatar.c"
		} else {
#line 186 "../src/contacts-avatar.vala"
			_tmp1_ = FALSE;
#line 1280 "contacts-avatar.c"
		}
#line 186 "../src/contacts-avatar.vala"
		if (_tmp1_) {
#line 1284 "contacts-avatar.c"
			FolksNameDetails* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 187 "../src/contacts-avatar.vala"
			_tmp8_ = n;
#line 187 "../src/contacts-avatar.vala"
			_tmp9_ = folks_name_details_get_full_name (_tmp8_);
#line 187 "../src/contacts-avatar.vala"
			_tmp10_ = _tmp9_;
#line 187 "../src/contacts-avatar.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 187 "../src/contacts-avatar.vala"
			result = _tmp11_;
#line 187 "../src/contacts-avatar.vala"
			return result;
#line 1301 "contacts-avatar.c"
		} else {
			FolksNameDetails* _tmp12_;
			FolksStructuredName* _tmp13_;
			FolksStructuredName* _tmp14_;
#line 188 "../src/contacts-avatar.vala"
			_tmp12_ = n;
#line 188 "../src/contacts-avatar.vala"
			_tmp13_ = folks_name_details_get_structured_name (_tmp12_);
#line 188 "../src/contacts-avatar.vala"
			_tmp14_ = _tmp13_;
#line 188 "../src/contacts-avatar.vala"
			if (_tmp14_ != NULL) {
#line 1314 "contacts-avatar.c"
				FolksNameDetails* _tmp15_;
				FolksStructuredName* _tmp16_;
				FolksStructuredName* _tmp17_;
				gchar* _tmp18_;
#line 189 "../src/contacts-avatar.vala"
				_tmp15_ = n;
#line 189 "../src/contacts-avatar.vala"
				_tmp16_ = folks_name_details_get_structured_name (_tmp15_);
#line 189 "../src/contacts-avatar.vala"
				_tmp17_ = _tmp16_;
#line 189 "../src/contacts-avatar.vala"
				_tmp18_ = folks_structured_name_to_string (_tmp17_);
#line 189 "../src/contacts-avatar.vala"
				result = _tmp18_;
#line 189 "../src/contacts-avatar.vala"
				return result;
#line 1331 "contacts-avatar.c"
			} else {
				FolksNameDetails* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
#line 190 "../src/contacts-avatar.vala"
				_tmp19_ = n;
#line 190 "../src/contacts-avatar.vala"
				_tmp20_ = folks_name_details_get_nickname (_tmp19_);
#line 190 "../src/contacts-avatar.vala"
				_tmp21_ = _tmp20_;
#line 190 "../src/contacts-avatar.vala"
				if (g_strcmp0 (_tmp21_, "") != 0) {
#line 1344 "contacts-avatar.c"
					FolksNameDetails* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
#line 191 "../src/contacts-avatar.vala"
					_tmp22_ = n;
#line 191 "../src/contacts-avatar.vala"
					_tmp23_ = folks_name_details_get_nickname (_tmp22_);
#line 191 "../src/contacts-avatar.vala"
					_tmp24_ = _tmp23_;
#line 191 "../src/contacts-avatar.vala"
					_tmp25_ = g_strdup (_tmp24_);
#line 191 "../src/contacts-avatar.vala"
					result = _tmp25_;
#line 191 "../src/contacts-avatar.vala"
					return result;
#line 1361 "contacts-avatar.c"
				}
			}
		}
	}
#line 194 "../src/contacts-avatar.vala"
	_tmp26_ = g_strdup ("");
#line 194 "../src/contacts-avatar.vala"
	result = _tmp26_;
#line 194 "../src/contacts-avatar.vala"
	return result;
#line 1372 "contacts-avatar.c"
}

FolksIndividual*
contacts_avatar_get_individual (ContactsAvatar* self)
{
	FolksIndividual* result;
	FolksIndividual* _tmp0_;
#line 28 "../src/contacts-avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/contacts-avatar.vala"
	_tmp0_ = self->priv->_individual;
#line 28 "../src/contacts-avatar.vala"
	result = _tmp0_;
#line 28 "../src/contacts-avatar.vala"
	return result;
#line 1388 "contacts-avatar.c"
}

void
contacts_avatar_set_individual (ContactsAvatar* self,
                                FolksIndividual* value)
{
	FolksIndividual* _tmp0_;
#line 29 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/contacts-avatar.vala"
	_tmp0_ = self->priv->_individual;
#line 30 "../src/contacts-avatar.vala"
	if (_tmp0_ == value) {
#line 31 "../src/contacts-avatar.vala"
		return;
#line 1404 "contacts-avatar.c"
	}
#line 33 "../src/contacts-avatar.vala"
	self->priv->_individual = value;
#line 34 "../src/contacts-avatar.vala"
	contacts_avatar_update_individual (self);
#line 29 "../src/contacts-avatar.vala"
	g_object_notify_by_pspec ((GObject *) self, contacts_avatar_properties[CONTACTS_AVATAR_INDIVIDUAL_PROPERTY]);
#line 1412 "contacts-avatar.c"
}

ContactsContact*
contacts_avatar_get_contact (ContactsAvatar* self)
{
	ContactsContact* result;
	ContactsContact* _tmp0_;
#line 40 "../src/contacts-avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/contacts-avatar.vala"
	_tmp0_ = self->priv->_contact;
#line 40 "../src/contacts-avatar.vala"
	result = _tmp0_;
#line 40 "../src/contacts-avatar.vala"
	return result;
#line 1428 "contacts-avatar.c"
}

void
contacts_avatar_set_contact (ContactsAvatar* self,
                             ContactsContact* value)
{
	ContactsContact* _tmp0_;
#line 41 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/contacts-avatar.vala"
	_tmp0_ = self->priv->_contact;
#line 42 "../src/contacts-avatar.vala"
	if (_tmp0_ == value) {
#line 43 "../src/contacts-avatar.vala"
		return;
#line 1444 "contacts-avatar.c"
	}
#line 45 "../src/contacts-avatar.vala"
	self->priv->_contact = value;
#line 46 "../src/contacts-avatar.vala"
	contacts_avatar_update_contact (self);
#line 41 "../src/contacts-avatar.vala"
	g_object_notify_by_pspec ((GObject *) self, contacts_avatar_properties[CONTACTS_AVATAR_CONTACT_PROPERTY]);
#line 1452 "contacts-avatar.c"
}

gint
contacts_avatar_get_avatar_size (ContactsAvatar* self)
{
	gint result;
#line 50 "../src/contacts-avatar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 50 "../src/contacts-avatar.vala"
	result = self->priv->_avatar_size;
#line 50 "../src/contacts-avatar.vala"
	return result;
#line 1465 "contacts-avatar.c"
}

void
contacts_avatar_set_avatar_size (ContactsAvatar* self,
                                 gint value)
{
	gint old_value;
#line 50 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/contacts-avatar.vala"
	old_value = contacts_avatar_get_avatar_size (self);
#line 50 "../src/contacts-avatar.vala"
	if (old_value != value) {
#line 50 "../src/contacts-avatar.vala"
		self->priv->_avatar_size = value;
#line 50 "../src/contacts-avatar.vala"
		g_object_notify_by_pspec ((GObject *) self, contacts_avatar_properties[CONTACTS_AVATAR_AVATAR_SIZE_PROPERTY]);
#line 1483 "contacts-avatar.c"
	}
}

static GObject *
contacts_avatar_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ContactsAvatar * self;
	gint _tmp0_;
	AdwAvatar* _tmp1_;
	AdwAvatar* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
#line 52 "../src/contacts-avatar.vala"
	parent_class = G_OBJECT_CLASS (contacts_avatar_parent_class);
#line 52 "../src/contacts-avatar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 52 "../src/contacts-avatar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_AVATAR, ContactsAvatar);
#line 53 "../src/contacts-avatar.vala"
	_tmp0_ = self->priv->_avatar_size;
#line 53 "../src/contacts-avatar.vala"
	_tmp1_ = (AdwAvatar*) adw_avatar_new (_tmp0_, "", FALSE);
#line 53 "../src/contacts-avatar.vala"
	g_object_ref_sink (_tmp1_);
#line 53 "../src/contacts-avatar.vala"
	_tmp2_ = _tmp1_;
#line 53 "../src/contacts-avatar.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp2_);
#line 53 "../src/contacts-avatar.vala"
	_g_object_unref0 (_tmp2_);
#line 54 "../src/contacts-avatar.vala"
	_tmp3_ = adw_bin_get_child ((AdwBin*) self);
#line 54 "../src/contacts-avatar.vala"
	_tmp4_ = _tmp3_;
#line 54 "../src/contacts-avatar.vala"
	g_object_bind_property_with_closures ((GObject*) self, "avatar-size", (GObject*) _tmp4_, "size", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 52 "../src/contacts-avatar.vala"
	return obj;
#line 1526 "contacts-avatar.c"
}

static void
contacts_avatar_class_init (ContactsAvatarClass * klass,
                            gpointer klass_data)
{
#line 24 "../src/contacts-avatar.vala"
	contacts_avatar_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/contacts-avatar.vala"
	g_type_class_adjust_private_offset (klass, &ContactsAvatar_private_offset);
#line 24 "../src/contacts-avatar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_contacts_avatar_get_property;
#line 24 "../src/contacts-avatar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_contacts_avatar_set_property;
#line 24 "../src/contacts-avatar.vala"
	G_OBJECT_CLASS (klass)->constructor = contacts_avatar_constructor;
#line 24 "../src/contacts-avatar.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_avatar_finalize;
#line 24 "../src/contacts-avatar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_AVATAR_INDIVIDUAL_PROPERTY, contacts_avatar_properties[CONTACTS_AVATAR_INDIVIDUAL_PROPERTY] = g_param_spec_object ("individual", "individual", "individual", FOLKS_TYPE_INDIVIDUAL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/contacts-avatar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_AVATAR_CONTACT_PROPERTY, contacts_avatar_properties[CONTACTS_AVATAR_CONTACT_PROPERTY] = g_param_spec_object ("contact", "contact", "contact", CONTACTS_TYPE_CONTACT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/contacts-avatar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_AVATAR_AVATAR_SIZE_PROPERTY, contacts_avatar_properties[CONTACTS_AVATAR_AVATAR_SIZE_PROPERTY] = g_param_spec_int ("avatar-size", "avatar-size", "avatar-size", G_MININT, G_MAXINT, 48, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1551 "contacts-avatar.c"
}

static void
contacts_avatar_instance_init (ContactsAvatar * self,
                               gpointer klass)
{
#line 24 "../src/contacts-avatar.vala"
	self->priv = contacts_avatar_get_instance_private (self);
#line 26 "../src/contacts-avatar.vala"
	self->priv->_individual = NULL;
#line 38 "../src/contacts-avatar.vala"
	self->priv->_contact = NULL;
#line 50 "../src/contacts-avatar.vala"
	self->priv->_avatar_size = 48;
#line 1566 "contacts-avatar.c"
}

static void
contacts_avatar_finalize (GObject * obj)
{
	ContactsAvatar * self;
#line 24 "../src/contacts-avatar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_AVATAR, ContactsAvatar);
#line 24 "../src/contacts-avatar.vala"
	G_OBJECT_CLASS (contacts_avatar_parent_class)->finalize (obj);
#line 1577 "contacts-avatar.c"
}

/**
 * The Avatar of a Contact is responsible for showing an {@link Folks.Individual}'s
 * avatar, or a fallback if it's not available.
 */
 G_GNUC_NO_INLINE static GType
contacts_avatar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContactsAvatarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_avatar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsAvatar), 0, (GInstanceInitFunc) contacts_avatar_instance_init, NULL };
	GType contacts_avatar_type_id;
	contacts_avatar_type_id = g_type_register_static (adw_bin_get_type (), "ContactsAvatar", &g_define_type_info, 0);
	ContactsAvatar_private_offset = g_type_add_instance_private (contacts_avatar_type_id, sizeof (ContactsAvatarPrivate));
	return contacts_avatar_type_id;
}

GType
contacts_avatar_get_type (void)
{
	static volatile gsize contacts_avatar_type_id__once = 0;
	if (g_once_init_enter (&contacts_avatar_type_id__once)) {
		GType contacts_avatar_type_id;
		contacts_avatar_type_id = contacts_avatar_get_type_once ();
		g_once_init_leave (&contacts_avatar_type_id__once, contacts_avatar_type_id);
	}
	return contacts_avatar_type_id__once;
}

static void
_vala_contacts_avatar_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	ContactsAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_AVATAR, ContactsAvatar);
#line 24 "../src/contacts-avatar.vala"
	switch (property_id) {
#line 24 "../src/contacts-avatar.vala"
		case CONTACTS_AVATAR_INDIVIDUAL_PROPERTY:
#line 24 "../src/contacts-avatar.vala"
		g_value_set_object (value, contacts_avatar_get_individual (self));
#line 24 "../src/contacts-avatar.vala"
		break;
#line 24 "../src/contacts-avatar.vala"
		case CONTACTS_AVATAR_CONTACT_PROPERTY:
#line 24 "../src/contacts-avatar.vala"
		g_value_set_object (value, contacts_avatar_get_contact (self));
#line 24 "../src/contacts-avatar.vala"
		break;
#line 24 "../src/contacts-avatar.vala"
		case CONTACTS_AVATAR_AVATAR_SIZE_PROPERTY:
#line 24 "../src/contacts-avatar.vala"
		g_value_set_int (value, contacts_avatar_get_avatar_size (self));
#line 24 "../src/contacts-avatar.vala"
		break;
#line 1634 "contacts-avatar.c"
		default:
#line 24 "../src/contacts-avatar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/contacts-avatar.vala"
		break;
#line 1640 "contacts-avatar.c"
	}
}

static void
_vala_contacts_avatar_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	ContactsAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_AVATAR, ContactsAvatar);
#line 24 "../src/contacts-avatar.vala"
	switch (property_id) {
#line 24 "../src/contacts-avatar.vala"
		case CONTACTS_AVATAR_INDIVIDUAL_PROPERTY:
#line 24 "../src/contacts-avatar.vala"
		contacts_avatar_set_individual (self, g_value_get_object (value));
#line 24 "../src/contacts-avatar.vala"
		break;
#line 24 "../src/contacts-avatar.vala"
		case CONTACTS_AVATAR_CONTACT_PROPERTY:
#line 24 "../src/contacts-avatar.vala"
		contacts_avatar_set_contact (self, g_value_get_object (value));
#line 24 "../src/contacts-avatar.vala"
		break;
#line 24 "../src/contacts-avatar.vala"
		case CONTACTS_AVATAR_AVATAR_SIZE_PROPERTY:
#line 24 "../src/contacts-avatar.vala"
		contacts_avatar_set_avatar_size (self, g_value_get_int (value));
#line 24 "../src/contacts-avatar.vala"
		break;
#line 1672 "contacts-avatar.c"
		default:
#line 24 "../src/contacts-avatar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/contacts-avatar.vala"
		break;
#line 1678 "contacts-avatar.c"
	}
}

