/* contacts-manual-filter.c generated by valac 0.56.13, the Vala compiler
 * generated from contacts-manual-filter.vala, do not modify */

/*
 * Copyright (C) 2023 Niels De Graef <nielsdegraef@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "contacts.h"
#include <glib.h>
#include <folks/folks.h>
#include <gtk/gtk.h>
#include <glib-object.h>

enum  {
	CONTACTS_MANUAL_FILTER_0_PROPERTY,
	CONTACTS_MANUAL_FILTER_NUM_PROPERTIES
};
static GParamSpec* contacts_manual_filter_properties[CONTACTS_MANUAL_FILTER_NUM_PROPERTIES];
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ContactsManualFilterPrivate {
	GPtrArray* hidden;
};

static gint ContactsManualFilter_private_offset;
static gpointer contacts_manual_filter_parent_class = NULL;

static gboolean contacts_manual_filter_real_match (GtkFilter* base,
                                            GObject* item);
static GtkFilterMatch contacts_manual_filter_real_get_strictness (GtkFilter* base);
static void contacts_manual_filter_finalize (GObject * obj);
static GType contacts_manual_filter_get_type_once (void);

static inline gpointer
contacts_manual_filter_get_instance_private (ContactsManualFilter* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsManualFilter_private_offset);
}

/**
   * Marks that the given individual should to be hidden
   */
void
contacts_manual_filter_add_individual (ContactsManualFilter* self,
                                       FolksIndividual* individual)
{
	GPtrArray* _tmp0_;
#line 34 "../src/contacts-manual-filter.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/contacts-manual-filter.vala"
	g_return_if_fail (individual != NULL);
#line 35 "../src/contacts-manual-filter.vala"
	_tmp0_ = self->priv->hidden;
#line 35 "../src/contacts-manual-filter.vala"
	g_ptr_array_add (_tmp0_, individual);
#line 36 "../src/contacts-manual-filter.vala"
	gtk_filter_changed ((GtkFilter*) self, GTK_FILTER_CHANGE_MORE_STRICT);
#line 76 "contacts-manual-filter.c"
}

/**
   * Marks that the given individual should no longer to be hidden
   */
void
contacts_manual_filter_remove_individual (ContactsManualFilter* self,
                                          FolksIndividual* individual)
{
	GPtrArray* _tmp0_;
	GPtrArray* _tmp1_;
#line 42 "../src/contacts-manual-filter.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/contacts-manual-filter.vala"
	g_return_if_fail (individual != NULL);
#line 42 "../src/contacts-manual-filter.vala"
	_tmp0_ = self->priv->hidden;
#line 42 "../src/contacts-manual-filter.vala"
	_vala_return_if_fail (g_ptr_array_find (_tmp0_, individual, NULL), "this.hidden.find (individual)");
#line 44 "../src/contacts-manual-filter.vala"
	_tmp1_ = self->priv->hidden;
#line 44 "../src/contacts-manual-filter.vala"
	g_ptr_array_remove (_tmp1_, individual);
#line 45 "../src/contacts-manual-filter.vala"
	gtk_filter_changed ((GtkFilter*) self, GTK_FILTER_CHANGE_LESS_STRICT);
#line 102 "contacts-manual-filter.c"
}

static gboolean
contacts_manual_filter_real_match (GtkFilter* base,
                                   GObject* item)
{
	ContactsManualFilter * self;
	GPtrArray* _tmp0_;
	gboolean result;
#line 48 "../src/contacts-manual-filter.vala"
	self = (ContactsManualFilter*) base;
#line 48 "../src/contacts-manual-filter.vala"
	_vala_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (item, FOLKS_TYPE_INDIVIDUAL), "item is Individual", FALSE);
#line 50 "../src/contacts-manual-filter.vala"
	_tmp0_ = self->priv->hidden;
#line 50 "../src/contacts-manual-filter.vala"
	result = !g_ptr_array_find (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (item, FOLKS_TYPE_INDIVIDUAL, FolksIndividual), NULL);
#line 50 "../src/contacts-manual-filter.vala"
	return result;
#line 122 "contacts-manual-filter.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5893 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5894 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5894 "glib-2.0.vapi"
	return result;
#line 135 "contacts-manual-filter.c"
}

static GtkFilterMatch
contacts_manual_filter_real_get_strictness (GtkFilter* base)
{
	ContactsManualFilter * self;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkFilterMatch result;
#line 53 "../src/contacts-manual-filter.vala"
	self = (ContactsManualFilter*) base;
#line 54 "../src/contacts-manual-filter.vala"
	_tmp0_ = self->priv->hidden;
#line 54 "../src/contacts-manual-filter.vala"
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
#line 54 "../src/contacts-manual-filter.vala"
	_tmp2_ = _tmp1_;
#line 54 "../src/contacts-manual-filter.vala"
	if (_tmp2_ == 0) {
#line 55 "../src/contacts-manual-filter.vala"
		result = GTK_FILTER_MATCH_ALL;
#line 55 "../src/contacts-manual-filter.vala"
		return result;
#line 160 "contacts-manual-filter.c"
	}
#line 57 "../src/contacts-manual-filter.vala"
	result = GTK_FILTER_MATCH_SOME;
#line 57 "../src/contacts-manual-filter.vala"
	return result;
#line 166 "contacts-manual-filter.c"
}

ContactsManualFilter*
contacts_manual_filter_construct (GType object_type)
{
	ContactsManualFilter * self = NULL;
#line 25 "../src/contacts-manual-filter.vala"
	self = (ContactsManualFilter*) g_object_new (object_type, NULL);
#line 25 "../src/contacts-manual-filter.vala"
	return self;
#line 177 "contacts-manual-filter.c"
}

ContactsManualFilter*
contacts_manual_filter_new (void)
{
#line 25 "../src/contacts-manual-filter.vala"
	return contacts_manual_filter_construct (CONTACTS_TYPE_MANUAL_FILTER);
#line 185 "contacts-manual-filter.c"
}

static void
contacts_manual_filter_class_init (ContactsManualFilterClass * klass,
                                   gpointer klass_data)
{
#line 25 "../src/contacts-manual-filter.vala"
	contacts_manual_filter_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/contacts-manual-filter.vala"
	g_type_class_adjust_private_offset (klass, &ContactsManualFilter_private_offset);
#line 25 "../src/contacts-manual-filter.vala"
	((GtkFilterClass *) klass)->match = (gboolean (*) (GtkFilter*, GObject*)) contacts_manual_filter_real_match;
#line 25 "../src/contacts-manual-filter.vala"
	((GtkFilterClass *) klass)->get_strictness = (GtkFilterMatch (*) (GtkFilter*)) contacts_manual_filter_real_get_strictness;
#line 25 "../src/contacts-manual-filter.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_manual_filter_finalize;
#line 202 "contacts-manual-filter.c"
}

static void
contacts_manual_filter_instance_init (ContactsManualFilter * self,
                                      gpointer klass)
{
	GPtrArray* _tmp0_;
#line 25 "../src/contacts-manual-filter.vala"
	self->priv = contacts_manual_filter_get_instance_private (self);
#line 29 "../src/contacts-manual-filter.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, NULL);
#line 29 "../src/contacts-manual-filter.vala"
	self->priv->hidden = _tmp0_;
#line 216 "contacts-manual-filter.c"
}

static void
contacts_manual_filter_finalize (GObject * obj)
{
	ContactsManualFilter * self;
#line 25 "../src/contacts-manual-filter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_MANUAL_FILTER, ContactsManualFilter);
#line 29 "../src/contacts-manual-filter.vala"
	_g_ptr_array_unref0 (self->priv->hidden);
#line 25 "../src/contacts-manual-filter.vala"
	G_OBJECT_CLASS (contacts_manual_filter_parent_class)->finalize (obj);
#line 229 "contacts-manual-filter.c"
}

/**
 * A subclass of {@link Gtk.Filter} which hides a programmatically chosen set
 * of individuals. The main use case here is to temporarily hide individuals
 * that are going to be deleted soon.
 */
 G_GNUC_NO_INLINE static GType
contacts_manual_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContactsManualFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_manual_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsManualFilter), 0, (GInstanceInitFunc) contacts_manual_filter_instance_init, NULL };
	GType contacts_manual_filter_type_id;
	contacts_manual_filter_type_id = g_type_register_static (gtk_filter_get_type (), "ContactsManualFilter", &g_define_type_info, 0);
	ContactsManualFilter_private_offset = g_type_add_instance_private (contacts_manual_filter_type_id, sizeof (ContactsManualFilterPrivate));
	return contacts_manual_filter_type_id;
}

GType
contacts_manual_filter_get_type (void)
{
	static volatile gsize contacts_manual_filter_type_id__once = 0;
	if (g_once_init_enter (&contacts_manual_filter_type_id__once)) {
		GType contacts_manual_filter_type_id;
		contacts_manual_filter_type_id = contacts_manual_filter_get_type_once ();
		g_once_init_leave (&contacts_manual_filter_type_id__once, contacts_manual_filter_type_id);
	}
	return contacts_manual_filter_type_id__once;
}

