/* contacts-store.c generated by valac 0.56.13, the Vala compiler
 * generated from contacts-store.vala, do not modify */

/*
 * Copyright (C) 2011 Alexander Larsson <alexl@redhat.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "contacts.h"
#include <folks/folks.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <folks/folks-eds.h>
#include <libedataserver/libedataserver.h>

enum  {
	CONTACTS_STORE_0_PROPERTY,
	CONTACTS_STORE_AGGREGATOR_PROPERTY,
	CONTACTS_STORE_BACKEND_STORE_PROPERTY,
	CONTACTS_STORE_ADDRESS_BOOKS_PROPERTY,
	CONTACTS_STORE_SORTER_PROPERTY,
	CONTACTS_STORE_QUERY_FILTER_PROPERTY,
	CONTACTS_STORE_MANUAL_FILTER_PROPERTY,
	CONTACTS_STORE_INDIVIDUALS_PROPERTY,
	CONTACTS_STORE_NUM_PROPERTIES
};
static GParamSpec* contacts_store_properties[CONTACTS_STORE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _ContactsStoreFindIndividualForQueryData ContactsStoreFindIndividualForQueryData;
typedef struct _Block3Data Block3Data;
typedef struct _ContactsStoreFindIndividualForIdData ContactsStoreFindIndividualForIdData;
enum  {
	CONTACTS_STORE_QUIESCENT_SIGNAL,
	CONTACTS_STORE_PREPARED_SIGNAL,
	CONTACTS_STORE_NUM_SIGNALS
};
static guint contacts_store_signals[CONTACTS_STORE_NUM_SIGNALS] = {0};

struct _ContactsStorePrivate {
	FolksIndividualAggregator* _aggregator;
	GListStore* _address_books;
	GListStore* base_model;
	GtkSortListModel* sort_model;
	ContactsIndividualSorter* _sorter;
	GtkFilterListModel* filter_model;
	ContactsQueryFilter* _query_filter;
	ContactsManualFilter* _manual_filter;
};

struct _Block2Data {
	int _ref_count_;
	ContactsStore* self;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
};

struct _ContactsStoreFindIndividualForQueryData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ContactsStore* self;
	FolksQuery* query;
	guint result;
	FolksIndividualAggregator* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	Block2Data* _data2_;
	gulong signal_id;
	gulong _tmp3_;
	guint matched_pos;
	guint strength;
	guint i;
	gboolean _tmp4_;
	guint _tmp5_;
	GListModel* _tmp6_;
	GListModel* _tmp7_;
	FolksIndividual* individual;
	GListModel* _tmp8_;
	GListModel* _tmp9_;
	GObject* _tmp10_;
	guint this_strength;
	FolksIndividual* _tmp11_;
};

struct _Block3Data {
	int _ref_count_;
	ContactsStore* self;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
};

struct _ContactsStoreFindIndividualForIdData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ContactsStore* self;
	gchar* id;
	guint result;
	FolksIndividualAggregator* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	Block3Data* _data3_;
	gulong signal_id;
	gulong _tmp3_;
	guint i;
	gboolean _tmp4_;
	guint _tmp5_;
	GListModel* _tmp6_;
	GListModel* _tmp7_;
	FolksIndividual* individual;
	GListModel* _tmp8_;
	GListModel* _tmp9_;
	GObject* _tmp10_;
	FolksIndividual* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
};

static gint ContactsStore_private_offset;
static gpointer contacts_store_parent_class = NULL;

static void contacts_store_read_dont_suggest_db (ContactsStore* self);
static void contacts_store_write_dont_suggest_db (ContactsStore* self);
static void contacts_store_set_sorter (ContactsStore* self,
                                ContactsIndividualSorter* value);
static void contacts_store_set_query_filter (ContactsStore* self,
                                      ContactsQueryFilter* value);
static void contacts_store_set_manual_filter (ContactsStore* self,
                                       ContactsManualFilter* value);
static void contacts_store_on_individuals_changed_detailed (ContactsStore* self,
                                                     GeeMultiMap* changes);
static void ______lambda6_ (ContactsStore* self,
                     GObject* obj,
                     GParamSpec* pspec);
static void _______lambda6__g_object_notify (GObject* _sender,
                                      GParamSpec* pspec,
                                      gpointer self);
static void contacts_store_find_individual_for_query_data_free (gpointer _data);
static gboolean contacts_store_find_individual_for_query_co (ContactsStoreFindIndividualForQueryData* _data_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean _contacts_store_find_individual_for_query_co_gsource_func (gpointer self);
static void ___lambda7_ (Block2Data* _data2_);
static void ____lambda7__contacts_store_quiescent (ContactsStore* _sender,
                                            gpointer self);
static void contacts_store_find_individual_for_id_data_free (gpointer _data);
static gboolean contacts_store_find_individual_for_id_co (ContactsStoreFindIndividualForIdData* _data_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean _contacts_store_find_individual_for_id_co_gsource_func (gpointer self);
static void ___lambda8_ (Block3Data* _data3_);
static void ____lambda8__contacts_store_quiescent (ContactsStore* _sender,
                                            gpointer self);
static gboolean contacts_store_non_linkable (ContactsStore* self,
                                      FolksIndividual* individual);
static gboolean contacts_store_has_mainable_persona (ContactsStore* self,
                                              FolksIndividual* individual);
static void contacts_store_set_aggregator (ContactsStore* self,
                                    FolksIndividualAggregator* value);
static GObject * contacts_store_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _contacts_store___lambda9_ (ContactsStore* self,
                                 FolksBackend* backend);
static void __contacts_store___lambda9__folks_backend_store_backend_available (FolksBackendStore* _sender,
                                                                        FolksBackend* backend,
                                                                        gpointer self);
static void _contacts_store___lambda10_ (ContactsStore* self,
                                  GObject* obj,
                                  GParamSpec* pspec);
static gboolean __lambda11_ (ContactsStore* self);
static gboolean ___lambda11__gsource_func (gpointer self);
static void __contacts_store___lambda10__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static void _contacts_store___lambda12_ (ContactsStore* self,
                                  GObject* obj,
                                  GParamSpec* pspec);
static gboolean __lambda13_ (ContactsStore* self);
static gboolean ___lambda13__gsource_func (gpointer self);
static void __contacts_store___lambda12__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static void _contacts_store_on_individuals_changed_detailed_folks_individual_aggregator_individuals_changed_detailed (FolksIndividualAggregator* _sender,
                                                                                                               GeeMultiMap* changes,
                                                                                                               gpointer self);
static void contacts_store_finalize (GObject * obj);
static GType contacts_store_get_type_once (void);
static void _vala_contacts_store_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_contacts_store_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
contacts_store_get_instance_private (ContactsStore* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsStore_private_offset);
}

static void
contacts_store_read_dont_suggest_db (ContactsStore* self)
{
	GeeHashMultiMap* _tmp0_;
	gchar* path = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 67 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/contacts-store.vala"
	_tmp0_ = self->dont_suggest_link;
#line 68 "../src/contacts-store.vala"
	gee_multi_map_clear ((GeeMultiMap*) _tmp0_);
#line 70 "../src/contacts-store.vala"
	_tmp1_ = g_get_user_config_dir ();
#line 70 "../src/contacts-store.vala"
	_tmp2_ = g_build_filename (_tmp1_, "gnome-contacts", "dont_suggest.db", NULL);
#line 70 "../src/contacts-store.vala"
	path = _tmp2_;
#line 259 "contacts-store.c"
	{
		gchar* contents = NULL;
		gchar* _tmp3_ = NULL;
		gchar** rows = NULL;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint rows_length1;
		gint _rows_size_;
		gchar** _tmp6_;
		gint _tmp6__length1;
#line 73 "../src/contacts-store.vala"
		g_file_get_contents (path, &_tmp3_, NULL, &_inner_error0_);
#line 73 "../src/contacts-store.vala"
		_g_free0 (contents);
#line 73 "../src/contacts-store.vala"
		contents = _tmp3_;
#line 73 "../src/contacts-store.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 73 "../src/contacts-store.vala"
			_g_free0 (contents);
#line 280 "contacts-store.c"
			goto __catch0_g_error;
		}
#line 75 "../src/contacts-store.vala"
		_tmp5_ = _tmp4_ = g_strsplit (contents, "\n", 0);
#line 75 "../src/contacts-store.vala"
		rows = _tmp5_;
#line 75 "../src/contacts-store.vala"
		rows_length1 = _vala_array_length (_tmp4_);
#line 75 "../src/contacts-store.vala"
		_rows_size_ = rows_length1;
#line 76 "../src/contacts-store.vala"
		_tmp6_ = rows;
#line 76 "../src/contacts-store.vala"
		_tmp6__length1 = rows_length1;
#line 295 "contacts-store.c"
		{
			gchar** r_collection = NULL;
			gint r_collection_length1 = 0;
			gint _r_collection_size_ = 0;
			gint r_it = 0;
#line 76 "../src/contacts-store.vala"
			r_collection = _tmp6_;
#line 76 "../src/contacts-store.vala"
			r_collection_length1 = _tmp6__length1;
#line 76 "../src/contacts-store.vala"
			for (r_it = 0; r_it < r_collection_length1; r_it = r_it + 1) {
#line 307 "contacts-store.c"
				const gchar* r = NULL;
#line 76 "../src/contacts-store.vala"
				r = r_collection[r_it];
#line 311 "contacts-store.c"
				{
					gchar** ids = NULL;
					const gchar* _tmp7_;
					gchar** _tmp8_;
					gchar** _tmp9_;
					gint ids_length1;
					gint _ids_size_;
					gchar** _tmp10_;
					gint _tmp10__length1;
#line 77 "../src/contacts-store.vala"
					_tmp7_ = r;
#line 77 "../src/contacts-store.vala"
					_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, " ", 0);
#line 77 "../src/contacts-store.vala"
					ids = _tmp9_;
#line 77 "../src/contacts-store.vala"
					ids_length1 = _vala_array_length (_tmp8_);
#line 77 "../src/contacts-store.vala"
					_ids_size_ = ids_length1;
#line 78 "../src/contacts-store.vala"
					_tmp10_ = ids;
#line 78 "../src/contacts-store.vala"
					_tmp10__length1 = ids_length1;
#line 78 "../src/contacts-store.vala"
					if (_tmp10__length1 == 2) {
#line 337 "contacts-store.c"
						GeeHashMultiMap* _tmp11_;
						gchar** _tmp12_;
						gint _tmp12__length1;
						const gchar* _tmp13_;
						gchar** _tmp14_;
						gint _tmp14__length1;
						const gchar* _tmp15_;
#line 79 "../src/contacts-store.vala"
						_tmp11_ = self->dont_suggest_link;
#line 79 "../src/contacts-store.vala"
						_tmp12_ = ids;
#line 79 "../src/contacts-store.vala"
						_tmp12__length1 = ids_length1;
#line 79 "../src/contacts-store.vala"
						_tmp13_ = _tmp12_[0];
#line 79 "../src/contacts-store.vala"
						_tmp14_ = ids;
#line 79 "../src/contacts-store.vala"
						_tmp14__length1 = ids_length1;
#line 79 "../src/contacts-store.vala"
						_tmp15_ = _tmp14_[1];
#line 79 "../src/contacts-store.vala"
						gee_multi_map_set ((GeeMultiMap*) _tmp11_, _tmp13_, _tmp15_);
#line 361 "contacts-store.c"
					}
#line 76 "../src/contacts-store.vala"
					ids = (_vala_array_free (ids, ids_length1, (GDestroyNotify) g_free), NULL);
#line 365 "contacts-store.c"
				}
			}
		}
#line 71 "../src/contacts-store.vala"
		rows = (_vala_array_free (rows, rows_length1, (GDestroyNotify) g_free), NULL);
#line 71 "../src/contacts-store.vala"
		_g_free0 (contents);
#line 373 "contacts-store.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 71 "../src/contacts-store.vala"
		e = _inner_error0_;
#line 71 "../src/contacts-store.vala"
		_inner_error0_ = NULL;
#line 83 "../src/contacts-store.vala"
		_tmp16_ = e;
#line 83 "../src/contacts-store.vala"
		if (g_error_matches (_tmp16_, G_FILE_ERROR, G_FILE_ERROR_NOENT)) {
#line 84 "../src/contacts-store.vala"
			_g_error_free0 (e);
#line 84 "../src/contacts-store.vala"
			_g_free0 (path);
#line 84 "../src/contacts-store.vala"
			return;
#line 396 "contacts-store.c"
		}
#line 86 "../src/contacts-store.vala"
		_tmp17_ = e;
#line 86 "../src/contacts-store.vala"
		_tmp18_ = _tmp17_->message;
#line 86 "../src/contacts-store.vala"
		g_warning ("contacts-store.vala:86: error loading no suggestion db: %s\n", _tmp18_);
#line 71 "../src/contacts-store.vala"
		_g_error_free0 (e);
#line 406 "contacts-store.c"
	}
	__finally0:
#line 71 "../src/contacts-store.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 71 "../src/contacts-store.vala"
		_g_free0 (path);
#line 71 "../src/contacts-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 71 "../src/contacts-store.vala"
		g_clear_error (&_inner_error0_);
#line 71 "../src/contacts-store.vala"
		return;
#line 419 "contacts-store.c"
	}
#line 67 "../src/contacts-store.vala"
	_g_free0 (path);
#line 423 "contacts-store.c"
}

static void
contacts_store_write_dont_suggest_db (ContactsStore* self)
{
	GError* _inner_error0_ = NULL;
#line 90 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 432 "contacts-store.c"
	{
		gchar* dir = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* path = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		GString* s = NULL;
		GString* _tmp5_;
		const gchar* _tmp26_;
		GString* _tmp27_;
		const gchar* _tmp28_;
		GString* _tmp29_;
#line 92 "../src/contacts-store.vala"
		_tmp0_ = g_get_user_config_dir ();
#line 92 "../src/contacts-store.vala"
		_tmp1_ = g_build_filename (_tmp0_, "gnome-contacts", NULL);
#line 92 "../src/contacts-store.vala"
		dir = _tmp1_;
#line 93 "../src/contacts-store.vala"
		_tmp2_ = dir;
#line 93 "../src/contacts-store.vala"
		g_mkdir_with_parents (_tmp2_, 0700);
#line 94 "../src/contacts-store.vala"
		_tmp3_ = dir;
#line 94 "../src/contacts-store.vala"
		_tmp4_ = g_build_filename (_tmp3_, "dont_suggest.db", NULL);
#line 94 "../src/contacts-store.vala"
		path = _tmp4_;
#line 96 "../src/contacts-store.vala"
		_tmp5_ = g_string_new ("");
#line 96 "../src/contacts-store.vala"
		s = _tmp5_;
#line 467 "contacts-store.c"
		{
			GeeIterator* _key_it = NULL;
			GeeHashMultiMap* _tmp6_;
			GeeSet* _tmp7_;
			GeeSet* _tmp8_;
			GeeIterator* _tmp9_;
			GeeIterator* _tmp10_;
#line 97 "../src/contacts-store.vala"
			_tmp6_ = self->dont_suggest_link;
#line 97 "../src/contacts-store.vala"
			_tmp7_ = gee_multi_map_get_keys ((GeeMultiMap*) _tmp6_);
#line 97 "../src/contacts-store.vala"
			_tmp8_ = _tmp7_;
#line 97 "../src/contacts-store.vala"
			_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
#line 97 "../src/contacts-store.vala"
			_tmp10_ = _tmp9_;
#line 97 "../src/contacts-store.vala"
			_g_object_unref0 (_tmp8_);
#line 97 "../src/contacts-store.vala"
			_key_it = _tmp10_;
#line 97 "../src/contacts-store.vala"
			while (TRUE) {
#line 491 "contacts-store.c"
				GeeIterator* _tmp11_;
				gchar* key = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
#line 97 "../src/contacts-store.vala"
				_tmp11_ = _key_it;
#line 97 "../src/contacts-store.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 97 "../src/contacts-store.vala"
					break;
#line 502 "contacts-store.c"
				}
#line 97 "../src/contacts-store.vala"
				_tmp12_ = _key_it;
#line 97 "../src/contacts-store.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 97 "../src/contacts-store.vala"
				key = (gchar*) _tmp13_;
#line 510 "contacts-store.c"
				{
					GeeIterator* _value_it = NULL;
					GeeHashMultiMap* _tmp14_;
					const gchar* _tmp15_;
					GeeCollection* _tmp16_;
					GeeCollection* _tmp17_;
					GeeIterator* _tmp18_;
					GeeIterator* _tmp19_;
#line 98 "../src/contacts-store.vala"
					_tmp14_ = self->dont_suggest_link;
#line 98 "../src/contacts-store.vala"
					_tmp15_ = key;
#line 98 "../src/contacts-store.vala"
					_tmp16_ = gee_multi_map_get ((GeeMultiMap*) _tmp14_, _tmp15_);
#line 98 "../src/contacts-store.vala"
					_tmp17_ = _tmp16_;
#line 98 "../src/contacts-store.vala"
					_tmp18_ = gee_iterable_iterator ((GeeIterable*) _tmp17_);
#line 98 "../src/contacts-store.vala"
					_tmp19_ = _tmp18_;
#line 98 "../src/contacts-store.vala"
					_g_object_unref0 (_tmp17_);
#line 98 "../src/contacts-store.vala"
					_value_it = _tmp19_;
#line 98 "../src/contacts-store.vala"
					while (TRUE) {
#line 537 "contacts-store.c"
						GeeIterator* _tmp20_;
						gchar* value = NULL;
						GeeIterator* _tmp21_;
						gpointer _tmp22_;
						GString* _tmp23_;
						const gchar* _tmp24_;
						const gchar* _tmp25_;
#line 98 "../src/contacts-store.vala"
						_tmp20_ = _value_it;
#line 98 "../src/contacts-store.vala"
						if (!gee_iterator_next (_tmp20_)) {
#line 98 "../src/contacts-store.vala"
							break;
#line 551 "contacts-store.c"
						}
#line 98 "../src/contacts-store.vala"
						_tmp21_ = _value_it;
#line 98 "../src/contacts-store.vala"
						_tmp22_ = gee_iterator_get (_tmp21_);
#line 98 "../src/contacts-store.vala"
						value = (gchar*) _tmp22_;
#line 99 "../src/contacts-store.vala"
						_tmp23_ = s;
#line 99 "../src/contacts-store.vala"
						_tmp24_ = key;
#line 99 "../src/contacts-store.vala"
						_tmp25_ = value;
#line 99 "../src/contacts-store.vala"
						g_string_append_printf (_tmp23_, "%s %s\n", _tmp24_, _tmp25_);
#line 98 "../src/contacts-store.vala"
						_g_free0 (value);
#line 569 "contacts-store.c"
					}
#line 98 "../src/contacts-store.vala"
					_g_object_unref0 (_value_it);
#line 573 "contacts-store.c"
				}
#line 97 "../src/contacts-store.vala"
				_g_free0 (key);
#line 577 "contacts-store.c"
			}
#line 97 "../src/contacts-store.vala"
			_g_object_unref0 (_key_it);
#line 581 "contacts-store.c"
		}
#line 101 "../src/contacts-store.vala"
		_tmp26_ = path;
#line 101 "../src/contacts-store.vala"
		_tmp27_ = s;
#line 101 "../src/contacts-store.vala"
		_tmp28_ = _tmp27_->str;
#line 101 "../src/contacts-store.vala"
		_tmp29_ = s;
#line 101 "../src/contacts-store.vala"
		g_file_set_contents (_tmp26_, _tmp28_, _tmp29_->len, &_inner_error0_);
#line 101 "../src/contacts-store.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 101 "../src/contacts-store.vala"
			_g_string_free0 (s);
#line 101 "../src/contacts-store.vala"
			_g_free0 (path);
#line 101 "../src/contacts-store.vala"
			_g_free0 (dir);
#line 601 "contacts-store.c"
			goto __catch0_g_error;
		}
#line 91 "../src/contacts-store.vala"
		_g_string_free0 (s);
#line 91 "../src/contacts-store.vala"
		_g_free0 (path);
#line 91 "../src/contacts-store.vala"
		_g_free0 (dir);
#line 610 "contacts-store.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 91 "../src/contacts-store.vala"
		e = _inner_error0_;
#line 91 "../src/contacts-store.vala"
		_inner_error0_ = NULL;
#line 103 "../src/contacts-store.vala"
		_tmp30_ = e;
#line 103 "../src/contacts-store.vala"
		_tmp31_ = _tmp30_->message;
#line 103 "../src/contacts-store.vala"
		g_warning ("contacts-store.vala:103: error writing no suggestion db: %s\n", _tmp31_);
#line 91 "../src/contacts-store.vala"
		_g_error_free0 (e);
#line 630 "contacts-store.c"
	}
	__finally0:
#line 91 "../src/contacts-store.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../src/contacts-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 91 "../src/contacts-store.vala"
		g_clear_error (&_inner_error0_);
#line 91 "../src/contacts-store.vala"
		return;
#line 641 "contacts-store.c"
	}
}

gboolean
contacts_store_may_suggest_link (ContactsStore* self,
                                 FolksIndividual* a,
                                 FolksIndividual* b)
{
	gboolean result;
#line 107 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 107 "../src/contacts-store.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 107 "../src/contacts-store.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 657 "contacts-store.c"
	{
		GeeIterator* _a_persona_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 108 "../src/contacts-store.vala"
		_tmp0_ = folks_individual_get_personas (a);
#line 108 "../src/contacts-store.vala"
		_tmp1_ = _tmp0_;
#line 108 "../src/contacts-store.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 108 "../src/contacts-store.vala"
		_a_persona_it = _tmp2_;
#line 108 "../src/contacts-store.vala"
		while (TRUE) {
#line 673 "contacts-store.c"
			GeeIterator* _tmp3_;
			FolksPersona* a_persona = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
#line 108 "../src/contacts-store.vala"
			_tmp3_ = _a_persona_it;
#line 108 "../src/contacts-store.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 108 "../src/contacts-store.vala"
				break;
#line 684 "contacts-store.c"
			}
#line 108 "../src/contacts-store.vala"
			_tmp4_ = _a_persona_it;
#line 108 "../src/contacts-store.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 108 "../src/contacts-store.vala"
			a_persona = (FolksPersona*) _tmp5_;
#line 692 "contacts-store.c"
			{
				GeeIterator* _no_link_uid_it = NULL;
				GeeHashMultiMap* _tmp6_;
				FolksPersona* _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				GeeCollection* _tmp10_;
				GeeCollection* _tmp11_;
				GeeIterator* _tmp12_;
				GeeIterator* _tmp13_;
#line 109 "../src/contacts-store.vala"
				_tmp6_ = self->dont_suggest_link;
#line 109 "../src/contacts-store.vala"
				_tmp7_ = a_persona;
#line 109 "../src/contacts-store.vala"
				_tmp8_ = folks_persona_get_uid (_tmp7_);
#line 109 "../src/contacts-store.vala"
				_tmp9_ = _tmp8_;
#line 109 "../src/contacts-store.vala"
				_tmp10_ = gee_multi_map_get ((GeeMultiMap*) _tmp6_, _tmp9_);
#line 109 "../src/contacts-store.vala"
				_tmp11_ = _tmp10_;
#line 109 "../src/contacts-store.vala"
				_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
#line 109 "../src/contacts-store.vala"
				_tmp13_ = _tmp12_;
#line 109 "../src/contacts-store.vala"
				_g_object_unref0 (_tmp11_);
#line 109 "../src/contacts-store.vala"
				_no_link_uid_it = _tmp13_;
#line 109 "../src/contacts-store.vala"
				while (TRUE) {
#line 725 "contacts-store.c"
					GeeIterator* _tmp14_;
					gchar* no_link_uid = NULL;
					GeeIterator* _tmp15_;
					gpointer _tmp16_;
#line 109 "../src/contacts-store.vala"
					_tmp14_ = _no_link_uid_it;
#line 109 "../src/contacts-store.vala"
					if (!gee_iterator_next (_tmp14_)) {
#line 109 "../src/contacts-store.vala"
						break;
#line 736 "contacts-store.c"
					}
#line 109 "../src/contacts-store.vala"
					_tmp15_ = _no_link_uid_it;
#line 109 "../src/contacts-store.vala"
					_tmp16_ = gee_iterator_get (_tmp15_);
#line 109 "../src/contacts-store.vala"
					no_link_uid = (gchar*) _tmp16_;
#line 744 "contacts-store.c"
					{
						GeeIterator* _b_persona_it = NULL;
						GeeSet* _tmp17_;
						GeeSet* _tmp18_;
						GeeIterator* _tmp19_;
#line 110 "../src/contacts-store.vala"
						_tmp17_ = folks_individual_get_personas (b);
#line 110 "../src/contacts-store.vala"
						_tmp18_ = _tmp17_;
#line 110 "../src/contacts-store.vala"
						_tmp19_ = gee_iterable_iterator ((GeeIterable*) _tmp18_);
#line 110 "../src/contacts-store.vala"
						_b_persona_it = _tmp19_;
#line 110 "../src/contacts-store.vala"
						while (TRUE) {
#line 760 "contacts-store.c"
							GeeIterator* _tmp20_;
							FolksPersona* b_persona = NULL;
							GeeIterator* _tmp21_;
							gpointer _tmp22_;
							FolksPersona* _tmp23_;
							const gchar* _tmp24_;
							const gchar* _tmp25_;
							const gchar* _tmp26_;
#line 110 "../src/contacts-store.vala"
							_tmp20_ = _b_persona_it;
#line 110 "../src/contacts-store.vala"
							if (!gee_iterator_next (_tmp20_)) {
#line 110 "../src/contacts-store.vala"
								break;
#line 775 "contacts-store.c"
							}
#line 110 "../src/contacts-store.vala"
							_tmp21_ = _b_persona_it;
#line 110 "../src/contacts-store.vala"
							_tmp22_ = gee_iterator_get (_tmp21_);
#line 110 "../src/contacts-store.vala"
							b_persona = (FolksPersona*) _tmp22_;
#line 111 "../src/contacts-store.vala"
							_tmp23_ = b_persona;
#line 111 "../src/contacts-store.vala"
							_tmp24_ = folks_persona_get_uid (_tmp23_);
#line 111 "../src/contacts-store.vala"
							_tmp25_ = _tmp24_;
#line 111 "../src/contacts-store.vala"
							_tmp26_ = no_link_uid;
#line 111 "../src/contacts-store.vala"
							if (g_strcmp0 (_tmp25_, _tmp26_) == 0) {
#line 112 "../src/contacts-store.vala"
								result = FALSE;
#line 112 "../src/contacts-store.vala"
								_g_object_unref0 (b_persona);
#line 112 "../src/contacts-store.vala"
								_g_object_unref0 (_b_persona_it);
#line 112 "../src/contacts-store.vala"
								_g_free0 (no_link_uid);
#line 112 "../src/contacts-store.vala"
								_g_object_unref0 (_no_link_uid_it);
#line 112 "../src/contacts-store.vala"
								_g_object_unref0 (a_persona);
#line 112 "../src/contacts-store.vala"
								_g_object_unref0 (_a_persona_it);
#line 112 "../src/contacts-store.vala"
								return result;
#line 809 "contacts-store.c"
							}
#line 110 "../src/contacts-store.vala"
							_g_object_unref0 (b_persona);
#line 813 "contacts-store.c"
						}
#line 110 "../src/contacts-store.vala"
						_g_object_unref0 (_b_persona_it);
#line 817 "contacts-store.c"
					}
#line 109 "../src/contacts-store.vala"
					_g_free0 (no_link_uid);
#line 821 "contacts-store.c"
				}
#line 109 "../src/contacts-store.vala"
				_g_object_unref0 (_no_link_uid_it);
#line 825 "contacts-store.c"
			}
#line 108 "../src/contacts-store.vala"
			_g_object_unref0 (a_persona);
#line 829 "contacts-store.c"
		}
#line 108 "../src/contacts-store.vala"
		_g_object_unref0 (_a_persona_it);
#line 833 "contacts-store.c"
	}
	{
		GeeIterator* _b_persona_it = NULL;
		GeeSet* _tmp27_;
		GeeSet* _tmp28_;
		GeeIterator* _tmp29_;
#line 116 "../src/contacts-store.vala"
		_tmp27_ = folks_individual_get_personas (b);
#line 116 "../src/contacts-store.vala"
		_tmp28_ = _tmp27_;
#line 116 "../src/contacts-store.vala"
		_tmp29_ = gee_iterable_iterator ((GeeIterable*) _tmp28_);
#line 116 "../src/contacts-store.vala"
		_b_persona_it = _tmp29_;
#line 116 "../src/contacts-store.vala"
		while (TRUE) {
#line 850 "contacts-store.c"
			GeeIterator* _tmp30_;
			FolksPersona* b_persona = NULL;
			GeeIterator* _tmp31_;
			gpointer _tmp32_;
#line 116 "../src/contacts-store.vala"
			_tmp30_ = _b_persona_it;
#line 116 "../src/contacts-store.vala"
			if (!gee_iterator_next (_tmp30_)) {
#line 116 "../src/contacts-store.vala"
				break;
#line 861 "contacts-store.c"
			}
#line 116 "../src/contacts-store.vala"
			_tmp31_ = _b_persona_it;
#line 116 "../src/contacts-store.vala"
			_tmp32_ = gee_iterator_get (_tmp31_);
#line 116 "../src/contacts-store.vala"
			b_persona = (FolksPersona*) _tmp32_;
#line 869 "contacts-store.c"
			{
				GeeIterator* _no_link_uid_it = NULL;
				GeeHashMultiMap* _tmp33_;
				FolksPersona* _tmp34_;
				const gchar* _tmp35_;
				const gchar* _tmp36_;
				GeeCollection* _tmp37_;
				GeeCollection* _tmp38_;
				GeeIterator* _tmp39_;
				GeeIterator* _tmp40_;
#line 117 "../src/contacts-store.vala"
				_tmp33_ = self->dont_suggest_link;
#line 117 "../src/contacts-store.vala"
				_tmp34_ = b_persona;
#line 117 "../src/contacts-store.vala"
				_tmp35_ = folks_persona_get_uid (_tmp34_);
#line 117 "../src/contacts-store.vala"
				_tmp36_ = _tmp35_;
#line 117 "../src/contacts-store.vala"
				_tmp37_ = gee_multi_map_get ((GeeMultiMap*) _tmp33_, _tmp36_);
#line 117 "../src/contacts-store.vala"
				_tmp38_ = _tmp37_;
#line 117 "../src/contacts-store.vala"
				_tmp39_ = gee_iterable_iterator ((GeeIterable*) _tmp38_);
#line 117 "../src/contacts-store.vala"
				_tmp40_ = _tmp39_;
#line 117 "../src/contacts-store.vala"
				_g_object_unref0 (_tmp38_);
#line 117 "../src/contacts-store.vala"
				_no_link_uid_it = _tmp40_;
#line 117 "../src/contacts-store.vala"
				while (TRUE) {
#line 902 "contacts-store.c"
					GeeIterator* _tmp41_;
					gchar* no_link_uid = NULL;
					GeeIterator* _tmp42_;
					gpointer _tmp43_;
#line 117 "../src/contacts-store.vala"
					_tmp41_ = _no_link_uid_it;
#line 117 "../src/contacts-store.vala"
					if (!gee_iterator_next (_tmp41_)) {
#line 117 "../src/contacts-store.vala"
						break;
#line 913 "contacts-store.c"
					}
#line 117 "../src/contacts-store.vala"
					_tmp42_ = _no_link_uid_it;
#line 117 "../src/contacts-store.vala"
					_tmp43_ = gee_iterator_get (_tmp42_);
#line 117 "../src/contacts-store.vala"
					no_link_uid = (gchar*) _tmp43_;
#line 921 "contacts-store.c"
					{
						GeeIterator* _a_persona_it = NULL;
						GeeSet* _tmp44_;
						GeeSet* _tmp45_;
						GeeIterator* _tmp46_;
#line 118 "../src/contacts-store.vala"
						_tmp44_ = folks_individual_get_personas (a);
#line 118 "../src/contacts-store.vala"
						_tmp45_ = _tmp44_;
#line 118 "../src/contacts-store.vala"
						_tmp46_ = gee_iterable_iterator ((GeeIterable*) _tmp45_);
#line 118 "../src/contacts-store.vala"
						_a_persona_it = _tmp46_;
#line 118 "../src/contacts-store.vala"
						while (TRUE) {
#line 937 "contacts-store.c"
							GeeIterator* _tmp47_;
							FolksPersona* a_persona = NULL;
							GeeIterator* _tmp48_;
							gpointer _tmp49_;
							FolksPersona* _tmp50_;
							const gchar* _tmp51_;
							const gchar* _tmp52_;
							const gchar* _tmp53_;
#line 118 "../src/contacts-store.vala"
							_tmp47_ = _a_persona_it;
#line 118 "../src/contacts-store.vala"
							if (!gee_iterator_next (_tmp47_)) {
#line 118 "../src/contacts-store.vala"
								break;
#line 952 "contacts-store.c"
							}
#line 118 "../src/contacts-store.vala"
							_tmp48_ = _a_persona_it;
#line 118 "../src/contacts-store.vala"
							_tmp49_ = gee_iterator_get (_tmp48_);
#line 118 "../src/contacts-store.vala"
							a_persona = (FolksPersona*) _tmp49_;
#line 119 "../src/contacts-store.vala"
							_tmp50_ = a_persona;
#line 119 "../src/contacts-store.vala"
							_tmp51_ = folks_persona_get_uid (_tmp50_);
#line 119 "../src/contacts-store.vala"
							_tmp52_ = _tmp51_;
#line 119 "../src/contacts-store.vala"
							_tmp53_ = no_link_uid;
#line 119 "../src/contacts-store.vala"
							if (g_strcmp0 (_tmp52_, _tmp53_) == 0) {
#line 120 "../src/contacts-store.vala"
								result = FALSE;
#line 120 "../src/contacts-store.vala"
								_g_object_unref0 (a_persona);
#line 120 "../src/contacts-store.vala"
								_g_object_unref0 (_a_persona_it);
#line 120 "../src/contacts-store.vala"
								_g_free0 (no_link_uid);
#line 120 "../src/contacts-store.vala"
								_g_object_unref0 (_no_link_uid_it);
#line 120 "../src/contacts-store.vala"
								_g_object_unref0 (b_persona);
#line 120 "../src/contacts-store.vala"
								_g_object_unref0 (_b_persona_it);
#line 120 "../src/contacts-store.vala"
								return result;
#line 986 "contacts-store.c"
							}
#line 118 "../src/contacts-store.vala"
							_g_object_unref0 (a_persona);
#line 990 "contacts-store.c"
						}
#line 118 "../src/contacts-store.vala"
						_g_object_unref0 (_a_persona_it);
#line 994 "contacts-store.c"
					}
#line 117 "../src/contacts-store.vala"
					_g_free0 (no_link_uid);
#line 998 "contacts-store.c"
				}
#line 117 "../src/contacts-store.vala"
				_g_object_unref0 (_no_link_uid_it);
#line 1002 "contacts-store.c"
			}
#line 116 "../src/contacts-store.vala"
			_g_object_unref0 (b_persona);
#line 1006 "contacts-store.c"
		}
#line 116 "../src/contacts-store.vala"
		_g_object_unref0 (_b_persona_it);
#line 1010 "contacts-store.c"
	}
#line 124 "../src/contacts-store.vala"
	result = TRUE;
#line 124 "../src/contacts-store.vala"
	return result;
#line 1016 "contacts-store.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 128 "../src/contacts-store.vala"
	return self ? g_object_ref (self) : NULL;
#line 1024 "contacts-store.c"
}

void
contacts_store_add_no_suggest_link (ContactsStore* self,
                                    FolksIndividual* a,
                                    FolksIndividual* b)
{
	FolksPersona* persona1 = NULL;
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	gint _tmp2_ = 0;
	gpointer* _tmp3_;
	FolksPersona** _tmp4_;
	gint _tmp4__length1;
	FolksPersona* _tmp5_;
	FolksPersona* _tmp6_;
	FolksPersona* _tmp7_;
	FolksPersona* persona2 = NULL;
	GeeSet* _tmp8_;
	GeeSet* _tmp9_;
	gint _tmp10_ = 0;
	gpointer* _tmp11_;
	FolksPersona** _tmp12_;
	gint _tmp12__length1;
	FolksPersona* _tmp13_;
	FolksPersona* _tmp14_;
	FolksPersona* _tmp15_;
	GeeHashMultiMap* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
#line 127 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/contacts-store.vala"
	g_return_if_fail (a != NULL);
#line 127 "../src/contacts-store.vala"
	g_return_if_fail (b != NULL);
#line 128 "../src/contacts-store.vala"
	_tmp0_ = folks_individual_get_personas (a);
#line 128 "../src/contacts-store.vala"
	_tmp1_ = _tmp0_;
#line 128 "../src/contacts-store.vala"
	_tmp3_ = gee_collection_to_array ((GeeCollection*) _tmp1_, &_tmp2_);
#line 128 "../src/contacts-store.vala"
	_tmp4_ = _tmp3_;
#line 128 "../src/contacts-store.vala"
	_tmp4__length1 = _tmp2_;
#line 128 "../src/contacts-store.vala"
	_tmp5_ = _tmp4_[0];
#line 128 "../src/contacts-store.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 128 "../src/contacts-store.vala"
	_tmp7_ = _tmp6_;
#line 128 "../src/contacts-store.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_object_unref), NULL);
#line 128 "../src/contacts-store.vala"
	persona1 = _tmp7_;
#line 129 "../src/contacts-store.vala"
	_tmp8_ = folks_individual_get_personas (b);
#line 129 "../src/contacts-store.vala"
	_tmp9_ = _tmp8_;
#line 129 "../src/contacts-store.vala"
	_tmp11_ = gee_collection_to_array ((GeeCollection*) _tmp9_, &_tmp10_);
#line 129 "../src/contacts-store.vala"
	_tmp12_ = _tmp11_;
#line 129 "../src/contacts-store.vala"
	_tmp12__length1 = _tmp10_;
#line 129 "../src/contacts-store.vala"
	_tmp13_ = _tmp12_[0];
#line 129 "../src/contacts-store.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 129 "../src/contacts-store.vala"
	_tmp15_ = _tmp14_;
#line 129 "../src/contacts-store.vala"
	_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_object_unref), NULL);
#line 129 "../src/contacts-store.vala"
	persona2 = _tmp15_;
#line 130 "../src/contacts-store.vala"
	_tmp16_ = self->dont_suggest_link;
#line 130 "../src/contacts-store.vala"
	_tmp17_ = folks_persona_get_uid (persona1);
#line 130 "../src/contacts-store.vala"
	_tmp18_ = _tmp17_;
#line 130 "../src/contacts-store.vala"
	_tmp19_ = folks_persona_get_uid (persona2);
#line 130 "../src/contacts-store.vala"
	_tmp20_ = _tmp19_;
#line 130 "../src/contacts-store.vala"
	gee_multi_map_set ((GeeMultiMap*) _tmp16_, _tmp18_, _tmp20_);
#line 131 "../src/contacts-store.vala"
	contacts_store_write_dont_suggest_db (self);
#line 127 "../src/contacts-store.vala"
	_g_object_unref0 (persona2);
#line 127 "../src/contacts-store.vala"
	_g_object_unref0 (persona1);
#line 1121 "contacts-store.c"
}

ContactsStore*
contacts_store_construct (GType object_type,
                          GSettings* settings,
                          FolksQuery* query)
{
	ContactsStore * self = NULL;
	ContactsIndividualSorter* _tmp0_;
	ContactsIndividualSorter* _tmp1_;
	GListStore* _tmp2_;
	GListModel* _tmp3_;
	ContactsIndividualSorter* _tmp4_;
	GtkSorter* _tmp5_;
	GtkSortListModel* _tmp6_;
	GtkSortListModel* _tmp7_;
	ContactsIndividualSectionSorter* _tmp8_;
	ContactsIndividualSectionSorter* _tmp9_;
	GtkEveryFilter* filter = NULL;
	GtkEveryFilter* _tmp10_;
	ContactsQueryFilter* _tmp11_;
	ContactsQueryFilter* _tmp12_;
	ContactsQueryFilter* _tmp13_;
	GtkFilter* _tmp14_;
	ContactsManualFilter* _tmp15_;
	ContactsManualFilter* _tmp16_;
	ContactsManualFilter* _tmp17_;
	GtkFilter* _tmp18_;
	GtkSortListModel* _tmp19_;
	GListModel* _tmp20_;
	GtkFilter* _tmp21_;
	GtkFilterListModel* _tmp22_;
#line 172 "../src/contacts-store.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 172 "../src/contacts-store.vala"
	g_return_val_if_fail (query != NULL, NULL);
#line 172 "../src/contacts-store.vala"
	self = (ContactsStore*) g_object_new (object_type, NULL);
#line 174 "../src/contacts-store.vala"
	_tmp0_ = contacts_individual_sorter_new (settings);
#line 174 "../src/contacts-store.vala"
	_tmp1_ = _tmp0_;
#line 174 "../src/contacts-store.vala"
	contacts_store_set_sorter (self, _tmp1_);
#line 174 "../src/contacts-store.vala"
	_g_object_unref0 (_tmp1_);
#line 175 "../src/contacts-store.vala"
	_tmp2_ = self->priv->base_model;
#line 175 "../src/contacts-store.vala"
	_tmp3_ = _g_object_ref0 ((GListModel*) _tmp2_);
#line 175 "../src/contacts-store.vala"
	_tmp4_ = self->priv->_sorter;
#line 175 "../src/contacts-store.vala"
	_tmp5_ = _g_object_ref0 ((GtkSorter*) _tmp4_);
#line 175 "../src/contacts-store.vala"
	_tmp6_ = gtk_sort_list_model_new (_tmp3_, _tmp5_);
#line 175 "../src/contacts-store.vala"
	_g_object_unref0 (self->priv->sort_model);
#line 175 "../src/contacts-store.vala"
	self->priv->sort_model = _tmp6_;
#line 176 "../src/contacts-store.vala"
	_tmp7_ = self->priv->sort_model;
#line 176 "../src/contacts-store.vala"
	_tmp8_ = contacts_individual_section_sorter_new ();
#line 176 "../src/contacts-store.vala"
	_tmp9_ = _tmp8_;
#line 176 "../src/contacts-store.vala"
	gtk_sort_list_model_set_section_sorter (_tmp7_, (GtkSorter*) _tmp9_);
#line 176 "../src/contacts-store.vala"
	_g_object_unref0 (_tmp9_);
#line 178 "../src/contacts-store.vala"
	_tmp10_ = gtk_every_filter_new ();
#line 178 "../src/contacts-store.vala"
	filter = _tmp10_;
#line 179 "../src/contacts-store.vala"
	_tmp11_ = contacts_query_filter_new (query);
#line 179 "../src/contacts-store.vala"
	_tmp12_ = _tmp11_;
#line 179 "../src/contacts-store.vala"
	contacts_store_set_query_filter (self, _tmp12_);
#line 179 "../src/contacts-store.vala"
	_g_object_unref0 (_tmp12_);
#line 180 "../src/contacts-store.vala"
	_tmp13_ = self->priv->_query_filter;
#line 180 "../src/contacts-store.vala"
	_tmp14_ = _g_object_ref0 ((GtkFilter*) _tmp13_);
#line 180 "../src/contacts-store.vala"
	gtk_multi_filter_append ((GtkMultiFilter*) filter, _tmp14_);
#line 181 "../src/contacts-store.vala"
	_tmp15_ = contacts_manual_filter_new ();
#line 181 "../src/contacts-store.vala"
	_tmp16_ = _tmp15_;
#line 181 "../src/contacts-store.vala"
	contacts_store_set_manual_filter (self, _tmp16_);
#line 181 "../src/contacts-store.vala"
	_g_object_unref0 (_tmp16_);
#line 182 "../src/contacts-store.vala"
	_tmp17_ = self->priv->_manual_filter;
#line 182 "../src/contacts-store.vala"
	_tmp18_ = _g_object_ref0 ((GtkFilter*) _tmp17_);
#line 182 "../src/contacts-store.vala"
	gtk_multi_filter_append ((GtkMultiFilter*) filter, _tmp18_);
#line 184 "../src/contacts-store.vala"
	_tmp19_ = self->priv->sort_model;
#line 184 "../src/contacts-store.vala"
	_tmp20_ = _g_object_ref0 ((GListModel*) _tmp19_);
#line 184 "../src/contacts-store.vala"
	_tmp21_ = _g_object_ref0 ((GtkFilter*) filter);
#line 184 "../src/contacts-store.vala"
	_tmp22_ = gtk_filter_list_model_new (_tmp20_, _tmp21_);
#line 184 "../src/contacts-store.vala"
	_g_object_unref0 (self->priv->filter_model);
#line 184 "../src/contacts-store.vala"
	self->priv->filter_model = _tmp22_;
#line 172 "../src/contacts-store.vala"
	_g_object_unref0 (filter);
#line 172 "../src/contacts-store.vala"
	return self;
#line 1240 "contacts-store.c"
}

ContactsStore*
contacts_store_new (GSettings* settings,
                    FolksQuery* query)
{
#line 172 "../src/contacts-store.vala"
	return contacts_store_construct (CONTACTS_TYPE_STORE, settings, query);
#line 1249 "contacts-store.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5893 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5894 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5894 "glib-2.0.vapi"
	return result;
#line 1262 "contacts-store.c"
}

static void
______lambda6_ (ContactsStore* self,
                GObject* obj,
                GParamSpec* pspec)
{
	const gchar* prop_name = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	guint pos = 0U;
	GListStore* _tmp4_;
	guint _tmp5_ = 0U;
	gboolean _tmp6_;
#line 224 "../src/contacts-store.vala"
	g_return_if_fail (obj != NULL);
#line 224 "../src/contacts-store.vala"
	g_return_if_fail (pspec != NULL);
#line 225 "../src/contacts-store.vala"
	_tmp0_ = g_param_spec_get_name (pspec);
#line 225 "../src/contacts-store.vala"
	prop_name = _tmp0_;
#line 226 "../src/contacts-store.vala"
	_tmp2_ = prop_name;
#line 226 "../src/contacts-store.vala"
	if (g_strcmp0 (_tmp2_, "display-name") != 0) {
#line 1290 "contacts-store.c"
		const gchar* _tmp3_;
#line 226 "../src/contacts-store.vala"
		_tmp3_ = prop_name;
#line 226 "../src/contacts-store.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "is-favourite") != 0;
#line 1296 "contacts-store.c"
	} else {
#line 226 "../src/contacts-store.vala"
		_tmp1_ = FALSE;
#line 1300 "contacts-store.c"
	}
#line 226 "../src/contacts-store.vala"
	if (_tmp1_) {
#line 227 "../src/contacts-store.vala"
		return;
#line 1306 "contacts-store.c"
	}
#line 230 "../src/contacts-store.vala"
	_tmp4_ = self->priv->base_model;
#line 230 "../src/contacts-store.vala"
	_tmp6_ = g_list_store_find (_tmp4_, obj, &_tmp5_);
#line 230 "../src/contacts-store.vala"
	pos = _tmp5_;
#line 230 "../src/contacts-store.vala"
	if (_tmp6_) {
#line 1316 "contacts-store.c"
		GListStore* _tmp7_;
#line 231 "../src/contacts-store.vala"
		_tmp7_ = self->priv->base_model;
#line 231 "../src/contacts-store.vala"
		g_list_model_items_changed ((GListModel*) _tmp7_, pos, (guint) 1, (guint) 1);
#line 1322 "contacts-store.c"
	}
}

static void
_______lambda6__g_object_notify (GObject* _sender,
                                 GParamSpec* pspec,
                                 gpointer self)
{
#line 224 "../src/contacts-store.vala"
	______lambda6_ ((ContactsStore*) self, _sender, pspec);
#line 1333 "contacts-store.c"
}

static void
contacts_store_on_individuals_changed_detailed (ContactsStore* self,
                                                GeeMultiMap* changes)
{
	GPtrArray* to_add = NULL;
	GPtrArray* _tmp0_;
	GPtrArray* to_remove = NULL;
	GPtrArray* _tmp1_;
	GPtrArray* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	GPtrArray* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	GPtrArray* _tmp32_;
	GListStore* _tmp58_;
	GListStore* _tmp59_;
	GPtrArray* _tmp60_;
	gpointer* _tmp61_;
	gint _tmp61__length1;
#line 187 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/contacts-store.vala"
	g_return_if_fail (changes != NULL);
#line 188 "../src/contacts-store.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, NULL);
#line 188 "../src/contacts-store.vala"
	to_add = _tmp0_;
#line 189 "../src/contacts-store.vala"
	_tmp1_ = g_ptr_array_new_full ((guint) 0, NULL);
#line 189 "../src/contacts-store.vala"
	to_remove = _tmp1_;
#line 1368 "contacts-store.c"
	{
		GeeIterator* _individual_it = NULL;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 191 "../src/contacts-store.vala"
		_tmp2_ = gee_multi_map_get_keys (changes);
#line 191 "../src/contacts-store.vala"
		_tmp3_ = _tmp2_;
#line 191 "../src/contacts-store.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 191 "../src/contacts-store.vala"
		_tmp5_ = _tmp4_;
#line 191 "../src/contacts-store.vala"
		_g_object_unref0 (_tmp3_);
#line 191 "../src/contacts-store.vala"
		_individual_it = _tmp5_;
#line 191 "../src/contacts-store.vala"
		while (TRUE) {
#line 1389 "contacts-store.c"
			GeeIterator* _tmp6_;
			FolksIndividual* individual = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			FolksIndividual* _tmp9_;
#line 191 "../src/contacts-store.vala"
			_tmp6_ = _individual_it;
#line 191 "../src/contacts-store.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 191 "../src/contacts-store.vala"
				break;
#line 1401 "contacts-store.c"
			}
#line 191 "../src/contacts-store.vala"
			_tmp7_ = _individual_it;
#line 191 "../src/contacts-store.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 191 "../src/contacts-store.vala"
			individual = (FolksIndividual*) _tmp8_;
#line 192 "../src/contacts-store.vala"
			_tmp9_ = individual;
#line 192 "../src/contacts-store.vala"
			if (_tmp9_ != NULL) {
#line 1413 "contacts-store.c"
				GPtrArray* _tmp10_;
				FolksIndividual* _tmp11_;
#line 193 "../src/contacts-store.vala"
				_tmp10_ = to_remove;
#line 193 "../src/contacts-store.vala"
				_tmp11_ = individual;
#line 193 "../src/contacts-store.vala"
				g_ptr_array_add (_tmp10_, _tmp11_);
#line 1422 "contacts-store.c"
			}
			{
				GeeIterator* _new_i_it = NULL;
				FolksIndividual* _tmp12_;
				GeeCollection* _tmp13_;
				GeeCollection* _tmp14_;
				GeeIterator* _tmp15_;
				GeeIterator* _tmp16_;
#line 194 "../src/contacts-store.vala"
				_tmp12_ = individual;
#line 194 "../src/contacts-store.vala"
				_tmp13_ = gee_multi_map_get (changes, _tmp12_);
#line 194 "../src/contacts-store.vala"
				_tmp14_ = _tmp13_;
#line 194 "../src/contacts-store.vala"
				_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
#line 194 "../src/contacts-store.vala"
				_tmp16_ = _tmp15_;
#line 194 "../src/contacts-store.vala"
				_g_object_unref0 (_tmp14_);
#line 194 "../src/contacts-store.vala"
				_new_i_it = _tmp16_;
#line 194 "../src/contacts-store.vala"
				while (TRUE) {
#line 1447 "contacts-store.c"
					GeeIterator* _tmp17_;
					FolksIndividual* new_i = NULL;
					GeeIterator* _tmp18_;
					gpointer _tmp19_;
					gboolean _tmp20_ = FALSE;
					FolksIndividual* _tmp21_;
#line 194 "../src/contacts-store.vala"
					_tmp17_ = _new_i_it;
#line 194 "../src/contacts-store.vala"
					if (!gee_iterator_next (_tmp17_)) {
#line 194 "../src/contacts-store.vala"
						break;
#line 1460 "contacts-store.c"
					}
#line 194 "../src/contacts-store.vala"
					_tmp18_ = _new_i_it;
#line 194 "../src/contacts-store.vala"
					_tmp19_ = gee_iterator_get (_tmp18_);
#line 194 "../src/contacts-store.vala"
					new_i = (FolksIndividual*) _tmp19_;
#line 195 "../src/contacts-store.vala"
					_tmp21_ = new_i;
#line 195 "../src/contacts-store.vala"
					if (_tmp21_ != NULL) {
#line 1472 "contacts-store.c"
						GPtrArray* _tmp22_;
						FolksIndividual* _tmp23_;
#line 195 "../src/contacts-store.vala"
						_tmp22_ = to_add;
#line 195 "../src/contacts-store.vala"
						_tmp23_ = new_i;
#line 195 "../src/contacts-store.vala"
						_tmp20_ = !g_ptr_array_find (_tmp22_, _tmp23_, NULL);
#line 1481 "contacts-store.c"
					} else {
#line 195 "../src/contacts-store.vala"
						_tmp20_ = FALSE;
#line 1485 "contacts-store.c"
					}
#line 195 "../src/contacts-store.vala"
					if (_tmp20_) {
#line 1489 "contacts-store.c"
						GPtrArray* _tmp24_;
						FolksIndividual* _tmp25_;
#line 196 "../src/contacts-store.vala"
						_tmp24_ = to_add;
#line 196 "../src/contacts-store.vala"
						_tmp25_ = new_i;
#line 196 "../src/contacts-store.vala"
						g_ptr_array_add (_tmp24_, _tmp25_);
#line 1498 "contacts-store.c"
					}
#line 194 "../src/contacts-store.vala"
					_g_object_unref0 (new_i);
#line 1502 "contacts-store.c"
				}
#line 194 "../src/contacts-store.vala"
				_g_object_unref0 (_new_i_it);
#line 1506 "contacts-store.c"
			}
#line 191 "../src/contacts-store.vala"
			_g_object_unref0 (individual);
#line 1510 "contacts-store.c"
		}
#line 191 "../src/contacts-store.vala"
		_g_object_unref0 (_individual_it);
#line 1514 "contacts-store.c"
	}
#line 200 "../src/contacts-store.vala"
	_tmp26_ = to_add;
#line 200 "../src/contacts-store.vala"
	_tmp27_ = vala_g_ptr_array_get_length (_tmp26_);
#line 200 "../src/contacts-store.vala"
	_tmp28_ = _tmp27_;
#line 200 "../src/contacts-store.vala"
	_tmp29_ = to_remove;
#line 200 "../src/contacts-store.vala"
	_tmp30_ = vala_g_ptr_array_get_length (_tmp29_);
#line 200 "../src/contacts-store.vala"
	_tmp31_ = _tmp30_;
#line 200 "../src/contacts-store.vala"
	g_debug ("contacts-store.vala:200: Individuals changed: %d added, %d removed", _tmp28_, _tmp31_);
#line 204 "../src/contacts-store.vala"
	_tmp32_ = to_remove;
#line 1532 "contacts-store.c"
	{
		GPtrArray* indiv_collection = NULL;
		guint indiv_index = 0U;
#line 204 "../src/contacts-store.vala"
		indiv_collection = _tmp32_;
#line 204 "../src/contacts-store.vala"
		for (indiv_index = 0; indiv_index < indiv_collection->len; indiv_index = indiv_index + 1) {
#line 1540 "contacts-store.c"
			FolksIndividual* indiv = NULL;
#line 204 "../src/contacts-store.vala"
			indiv = g_ptr_array_index (indiv_collection, indiv_index);
#line 1544 "contacts-store.c"
			{
				guint pos = 0U;
				GListStore* _tmp33_;
				FolksIndividual* _tmp34_;
				guint _tmp35_ = 0U;
				gboolean _tmp36_;
#line 205 "../src/contacts-store.vala"
				pos = (guint) 0;
#line 206 "../src/contacts-store.vala"
				_tmp33_ = self->priv->base_model;
#line 206 "../src/contacts-store.vala"
				_tmp34_ = indiv;
#line 206 "../src/contacts-store.vala"
				_tmp36_ = g_list_store_find (_tmp33_, (GObject*) _tmp34_, &_tmp35_);
#line 206 "../src/contacts-store.vala"
				pos = _tmp35_;
#line 206 "../src/contacts-store.vala"
				if (_tmp36_) {
#line 1563 "contacts-store.c"
					GListStore* _tmp37_;
#line 207 "../src/contacts-store.vala"
					_tmp37_ = self->priv->base_model;
#line 207 "../src/contacts-store.vala"
					g_list_store_remove (_tmp37_, pos);
#line 1569 "contacts-store.c"
				} else {
					FolksIndividual* _tmp38_;
					const gchar* _tmp39_;
					const gchar* _tmp40_;
#line 209 "../src/contacts-store.vala"
					_tmp38_ = indiv;
#line 209 "../src/contacts-store.vala"
					_tmp39_ = folks_individual_get_display_name (_tmp38_);
#line 209 "../src/contacts-store.vala"
					_tmp40_ = _tmp39_;
#line 209 "../src/contacts-store.vala"
					g_debug ("contacts-store.vala:209: Tried to remove individual '%s', but could't " \
"find it", _tmp40_);
#line 1582 "contacts-store.c"
				}
			}
		}
	}
	{
		guint i = 0U;
#line 214 "../src/contacts-store.vala"
		i = (guint) 0;
#line 1591 "contacts-store.c"
		{
			gboolean _tmp41_ = FALSE;
#line 214 "../src/contacts-store.vala"
			_tmp41_ = TRUE;
#line 214 "../src/contacts-store.vala"
			while (TRUE) {
#line 1598 "contacts-store.c"
				GPtrArray* _tmp43_;
				gint _tmp44_;
				gint _tmp45_;
				FolksIndividual* indiv = NULL;
				GPtrArray* _tmp46_;
				gconstpointer _tmp47_;
				gboolean _tmp48_ = FALSE;
				FolksIndividual* _tmp49_;
				GeeSet* _tmp50_;
				GeeSet* _tmp51_;
				gint _tmp52_;
				gint _tmp53_;
#line 214 "../src/contacts-store.vala"
				if (!_tmp41_) {
#line 1613 "contacts-store.c"
					guint _tmp42_;
#line 214 "../src/contacts-store.vala"
					_tmp42_ = i;
#line 214 "../src/contacts-store.vala"
					i = _tmp42_ + 1;
#line 1619 "contacts-store.c"
				}
#line 214 "../src/contacts-store.vala"
				_tmp41_ = FALSE;
#line 214 "../src/contacts-store.vala"
				_tmp43_ = to_add;
#line 214 "../src/contacts-store.vala"
				_tmp44_ = vala_g_ptr_array_get_length (_tmp43_);
#line 214 "../src/contacts-store.vala"
				_tmp45_ = _tmp44_;
#line 214 "../src/contacts-store.vala"
				if (!(i < ((guint) _tmp45_))) {
#line 214 "../src/contacts-store.vala"
					break;
#line 1633 "contacts-store.c"
				}
#line 215 "../src/contacts-store.vala"
				_tmp46_ = to_add;
#line 215 "../src/contacts-store.vala"
				_tmp47_ = g_ptr_array_index (_tmp46_, i);
#line 215 "../src/contacts-store.vala"
				indiv = (FolksIndividual*) _tmp47_;
#line 216 "../src/contacts-store.vala"
				_tmp49_ = indiv;
#line 216 "../src/contacts-store.vala"
				_tmp50_ = folks_individual_get_personas (_tmp49_);
#line 216 "../src/contacts-store.vala"
				_tmp51_ = _tmp50_;
#line 216 "../src/contacts-store.vala"
				_tmp52_ = gee_collection_get_size ((GeeCollection*) _tmp51_);
#line 216 "../src/contacts-store.vala"
				_tmp53_ = _tmp52_;
#line 216 "../src/contacts-store.vala"
				if (_tmp53_ == 0) {
#line 216 "../src/contacts-store.vala"
					_tmp48_ = TRUE;
#line 1655 "contacts-store.c"
				} else {
					FolksIndividual* _tmp54_;
#line 216 "../src/contacts-store.vala"
					_tmp54_ = indiv;
#line 216 "../src/contacts-store.vala"
					_tmp48_ = contacts_utils_is_ignorable (_tmp54_);
#line 1662 "contacts-store.c"
				}
#line 216 "../src/contacts-store.vala"
				if (_tmp48_) {
#line 1666 "contacts-store.c"
					GPtrArray* _tmp55_;
					guint _tmp56_;
#line 217 "../src/contacts-store.vala"
					_tmp55_ = to_add;
#line 217 "../src/contacts-store.vala"
					g_ptr_array_remove_index_fast (_tmp55_, i);
#line 218 "../src/contacts-store.vala"
					_tmp56_ = i;
#line 218 "../src/contacts-store.vala"
					i = _tmp56_ - 1;
#line 1677 "contacts-store.c"
				} else {
					FolksIndividual* _tmp57_;
#line 224 "../src/contacts-store.vala"
					_tmp57_ = indiv;
#line 224 "../src/contacts-store.vala"
					g_signal_connect_object ((GObject*) _tmp57_, "notify", (GCallback) _______lambda6__g_object_notify, self, 0);
#line 1684 "contacts-store.c"
				}
			}
		}
	}
#line 236 "../src/contacts-store.vala"
	_tmp58_ = self->priv->base_model;
#line 236 "../src/contacts-store.vala"
	_tmp59_ = self->priv->base_model;
#line 236 "../src/contacts-store.vala"
	_tmp60_ = to_add;
#line 236 "../src/contacts-store.vala"
	_tmp61_ = _tmp60_->pdata;
#line 236 "../src/contacts-store.vala"
	_tmp61__length1 = _tmp60_->len;
#line 236 "../src/contacts-store.vala"
	g_list_store_splice (_tmp58_, g_list_model_get_n_items ((GListModel*) _tmp59_), (guint) 0, (GObject**) _tmp61_, (guint) ((_tmp61__length1 * sizeof (FolksIndividual*)) / sizeof (GObject*)));
#line 187 "../src/contacts-store.vala"
	_g_ptr_array_unref0 (to_remove);
#line 187 "../src/contacts-store.vala"
	_g_ptr_array_unref0 (to_add);
#line 1705 "contacts-store.c"
}

static void
contacts_store_find_individual_for_query_data_free (gpointer _data)
{
	ContactsStoreFindIndividualForQueryData* _data_;
	_data_ = _data;
#line 35 "../src/contacts-store.vala"
	_g_object_unref0 (_data_->query);
#line 35 "../src/contacts-store.vala"
	_g_object_unref0 (_data_->self);
#line 35 "../src/contacts-store.vala"
	g_slice_free (ContactsStoreFindIndividualForQueryData, _data_);
#line 1719 "contacts-store.c"
}

void
contacts_store_find_individual_for_query (ContactsStore* self,
                                          FolksQuery* query,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	ContactsStoreFindIndividualForQueryData* _data_;
	ContactsStore* _tmp0_;
	FolksQuery* _tmp1_;
#line 35 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/contacts-store.vala"
	g_return_if_fail (query != NULL);
#line 35 "../src/contacts-store.vala"
	_data_ = g_slice_new0 (ContactsStoreFindIndividualForQueryData);
#line 35 "../src/contacts-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 35 "../src/contacts-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, contacts_store_find_individual_for_query_data_free);
#line 35 "../src/contacts-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 35 "../src/contacts-store.vala"
	_data_->self = _tmp0_;
#line 35 "../src/contacts-store.vala"
	_tmp1_ = _g_object_ref0 (query);
#line 35 "../src/contacts-store.vala"
	_g_object_unref0 (_data_->query);
#line 35 "../src/contacts-store.vala"
	_data_->query = _tmp1_;
#line 35 "../src/contacts-store.vala"
	contacts_store_find_individual_for_query_co (_data_);
#line 1753 "contacts-store.c"
}

guint
contacts_store_find_individual_for_query_finish (ContactsStore* self,
                                                 GAsyncResult* _res_)
{
	guint result;
	ContactsStoreFindIndividualForQueryData* _data_;
#line 35 "../src/contacts-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 35 "../src/contacts-store.vala"
	result = _data_->result;
#line 35 "../src/contacts-store.vala"
	return result;
#line 1768 "contacts-store.c"
}

/**
   * A helper method to find a contact based on the given search query, while
   * making sure to take care of (wait for) the "quiescent" property of the
   * IndividualAggregator.
   */
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 246 "../src/contacts-store.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 246 "../src/contacts-store.vala"
	return _data2_;
#line 1783 "contacts-store.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 246 "../src/contacts-store.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1793 "contacts-store.c"
		ContactsStore* self;
#line 246 "../src/contacts-store.vala"
		self = _data2_->self;
#line 246 "../src/contacts-store.vala"
		(_data2_->callback_target_destroy_notify == NULL) ? NULL : (_data2_->callback_target_destroy_notify (_data2_->callback_target), NULL);
#line 246 "../src/contacts-store.vala"
		_data2_->callback = NULL;
#line 246 "../src/contacts-store.vala"
		_data2_->callback_target = NULL;
#line 246 "../src/contacts-store.vala"
		_data2_->callback_target_destroy_notify = NULL;
#line 246 "../src/contacts-store.vala"
		_g_object_unref0 (self);
#line 246 "../src/contacts-store.vala"
		g_slice_free (Block2Data, _data2_);
#line 1809 "contacts-store.c"
	}
}

static gboolean
_contacts_store_find_individual_for_query_co_gsource_func (gpointer self)
{
	gboolean result;
	result = contacts_store_find_individual_for_query_co (self);
#line 248 "../src/contacts-store.vala"
	return result;
#line 1820 "contacts-store.c"
}

static void
___lambda7_ (Block2Data* _data2_)
{
	ContactsStore* self;
	GSourceFunc _tmp0_;
	gpointer _tmp0__target;
#line 249 "../src/contacts-store.vala"
	self = _data2_->self;
#line 250 "../src/contacts-store.vala"
	_tmp0_ = _data2_->callback;
#line 250 "../src/contacts-store.vala"
	_tmp0__target = _data2_->callback_target;
#line 250 "../src/contacts-store.vala"
	_tmp0_ (_tmp0__target);
#line 1837 "contacts-store.c"
}

static void
____lambda7__contacts_store_quiescent (ContactsStore* _sender,
                                       gpointer self)
{
#line 249 "../src/contacts-store.vala"
	___lambda7_ (self);
#line 1846 "contacts-store.c"
}

static gboolean
contacts_store_find_individual_for_query_co (ContactsStoreFindIndividualForQueryData* _data_)
{
#line 244 "../src/contacts-store.vala"
	switch (_data_->_state_) {
#line 244 "../src/contacts-store.vala"
		case 0:
#line 1856 "contacts-store.c"
		goto _state_0;
#line 244 "../src/contacts-store.vala"
		case 1:
#line 1860 "contacts-store.c"
		goto _state_1;
		default:
#line 244 "../src/contacts-store.vala"
		g_assert_not_reached ();
#line 1865 "contacts-store.c"
	}
	_state_0:
#line 246 "../src/contacts-store.vala"
	_data_->_tmp0_ = _data_->self->priv->_aggregator;
#line 246 "../src/contacts-store.vala"
	_data_->_tmp1_ = folks_individual_aggregator_get_is_quiescent (_data_->_tmp0_);
#line 246 "../src/contacts-store.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 246 "../src/contacts-store.vala"
	if (!_data_->_tmp2_) {
#line 246 "../src/contacts-store.vala"
		_data_->_data2_ = g_slice_new0 (Block2Data);
#line 246 "../src/contacts-store.vala"
		_data_->_data2_->_ref_count_ = 1;
#line 246 "../src/contacts-store.vala"
		_data_->_data2_->self = g_object_ref (_data_->self);
#line 248 "../src/contacts-store.vala"
		_data_->_data2_->callback = _contacts_store_find_individual_for_query_co_gsource_func;
#line 248 "../src/contacts-store.vala"
		_data_->_data2_->callback_target = _data_;
#line 248 "../src/contacts-store.vala"
		_data_->_data2_->callback_target_destroy_notify = NULL;
#line 249 "../src/contacts-store.vala"
		_data_->_tmp3_ = g_signal_connect_data (_data_->self, "quiescent", (GCallback) ____lambda7__contacts_store_quiescent, block2_data_ref (_data_->_data2_), (GClosureNotify) block2_data_unref, 0);
#line 249 "../src/contacts-store.vala"
		_data_->signal_id = _data_->_tmp3_;
#line 252 "../src/contacts-store.vala"
		_data_->_state_ = 1;
#line 252 "../src/contacts-store.vala"
		return FALSE;
#line 1896 "contacts-store.c"
		_state_1:
		;
#line 253 "../src/contacts-store.vala"
		g_signal_handler_disconnect ((GObject*) _data_->self, _data_->signal_id);
#line 246 "../src/contacts-store.vala"
		block2_data_unref (_data_->_data2_);
#line 246 "../src/contacts-store.vala"
		_data_->_data2_ = NULL;
#line 1905 "contacts-store.c"
	}
#line 257 "../src/contacts-store.vala"
	_data_->matched_pos = GTK_INVALID_LIST_POSITION;
#line 258 "../src/contacts-store.vala"
	_data_->strength = (guint) 0;
#line 1911 "contacts-store.c"
	{
#line 259 "../src/contacts-store.vala"
		_data_->i = (guint) 0;
#line 1915 "contacts-store.c"
		{
#line 259 "../src/contacts-store.vala"
			_data_->_tmp4_ = TRUE;
#line 259 "../src/contacts-store.vala"
			while (TRUE) {
#line 259 "../src/contacts-store.vala"
				if (!_data_->_tmp4_) {
#line 259 "../src/contacts-store.vala"
					_data_->_tmp5_ = _data_->i;
#line 259 "../src/contacts-store.vala"
					_data_->i = _data_->_tmp5_ + 1;
#line 1927 "contacts-store.c"
				}
#line 259 "../src/contacts-store.vala"
				_data_->_tmp4_ = FALSE;
#line 259 "../src/contacts-store.vala"
				_data_->_tmp6_ = contacts_store_get_individuals (_data_->self);
#line 259 "../src/contacts-store.vala"
				_data_->_tmp7_ = _data_->_tmp6_;
#line 259 "../src/contacts-store.vala"
				if (!(_data_->i < g_list_model_get_n_items (_data_->_tmp7_))) {
#line 259 "../src/contacts-store.vala"
					break;
#line 1939 "contacts-store.c"
				}
#line 260 "../src/contacts-store.vala"
				_data_->_tmp8_ = contacts_store_get_individuals (_data_->self);
#line 260 "../src/contacts-store.vala"
				_data_->_tmp9_ = _data_->_tmp8_;
#line 260 "../src/contacts-store.vala"
				_data_->_tmp10_ = g_list_model_get_item (_data_->_tmp9_, _data_->i);
#line 260 "../src/contacts-store.vala"
				_data_->individual = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, FOLKS_TYPE_INDIVIDUAL, FolksIndividual);
#line 261 "../src/contacts-store.vala"
				_data_->_tmp11_ = _data_->individual;
#line 261 "../src/contacts-store.vala"
				_data_->this_strength = folks_query_is_match (_data_->query, _data_->_tmp11_);
#line 262 "../src/contacts-store.vala"
				if (_data_->this_strength > _data_->strength) {
#line 263 "../src/contacts-store.vala"
					_data_->matched_pos = _data_->i;
#line 264 "../src/contacts-store.vala"
					_data_->strength = _data_->this_strength;
#line 1959 "contacts-store.c"
				}
#line 259 "../src/contacts-store.vala"
				_g_object_unref0 (_data_->individual);
#line 1963 "contacts-store.c"
			}
		}
	}
#line 268 "../src/contacts-store.vala"
	_data_->result = _data_->matched_pos;
#line 268 "../src/contacts-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 268 "../src/contacts-store.vala"
	if (_data_->_state_ != 0) {
#line 268 "../src/contacts-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 268 "../src/contacts-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1977 "contacts-store.c"
		}
	}
#line 268 "../src/contacts-store.vala"
	g_object_unref (_data_->_async_result);
#line 268 "../src/contacts-store.vala"
	return FALSE;
#line 1984 "contacts-store.c"
}

static void
contacts_store_find_individual_for_id_data_free (gpointer _data)
{
	ContactsStoreFindIndividualForIdData* _data_;
	_data_ = _data;
#line 35 "../src/contacts-store.vala"
	_g_free0 (_data_->id);
#line 35 "../src/contacts-store.vala"
	_g_object_unref0 (_data_->self);
#line 35 "../src/contacts-store.vala"
	g_slice_free (ContactsStoreFindIndividualForIdData, _data_);
#line 1998 "contacts-store.c"
}

void
contacts_store_find_individual_for_id (ContactsStore* self,
                                       const gchar* id,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	ContactsStoreFindIndividualForIdData* _data_;
	ContactsStore* _tmp0_;
	gchar* _tmp1_;
#line 35 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/contacts-store.vala"
	g_return_if_fail (id != NULL);
#line 35 "../src/contacts-store.vala"
	_data_ = g_slice_new0 (ContactsStoreFindIndividualForIdData);
#line 35 "../src/contacts-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 35 "../src/contacts-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, contacts_store_find_individual_for_id_data_free);
#line 35 "../src/contacts-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 35 "../src/contacts-store.vala"
	_data_->self = _tmp0_;
#line 35 "../src/contacts-store.vala"
	_tmp1_ = g_strdup (id);
#line 35 "../src/contacts-store.vala"
	_g_free0 (_data_->id);
#line 35 "../src/contacts-store.vala"
	_data_->id = _tmp1_;
#line 35 "../src/contacts-store.vala"
	contacts_store_find_individual_for_id_co (_data_);
#line 2032 "contacts-store.c"
}

guint
contacts_store_find_individual_for_id_finish (ContactsStore* self,
                                              GAsyncResult* _res_)
{
	guint result;
	ContactsStoreFindIndividualForIdData* _data_;
#line 35 "../src/contacts-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 35 "../src/contacts-store.vala"
	result = _data_->result;
#line 35 "../src/contacts-store.vala"
	return result;
#line 2047 "contacts-store.c"
}

/**
   * A helper method to find a contact based on the given individual id, while
   * making sure to take care of (wait for) the "quiescent" property of the
   * IndividualAggregator.
   */
static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 278 "../src/contacts-store.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 278 "../src/contacts-store.vala"
	return _data3_;
#line 2062 "contacts-store.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 278 "../src/contacts-store.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 2072 "contacts-store.c"
		ContactsStore* self;
#line 278 "../src/contacts-store.vala"
		self = _data3_->self;
#line 278 "../src/contacts-store.vala"
		(_data3_->callback_target_destroy_notify == NULL) ? NULL : (_data3_->callback_target_destroy_notify (_data3_->callback_target), NULL);
#line 278 "../src/contacts-store.vala"
		_data3_->callback = NULL;
#line 278 "../src/contacts-store.vala"
		_data3_->callback_target = NULL;
#line 278 "../src/contacts-store.vala"
		_data3_->callback_target_destroy_notify = NULL;
#line 278 "../src/contacts-store.vala"
		_g_object_unref0 (self);
#line 278 "../src/contacts-store.vala"
		g_slice_free (Block3Data, _data3_);
#line 2088 "contacts-store.c"
	}
}

static gboolean
_contacts_store_find_individual_for_id_co_gsource_func (gpointer self)
{
	gboolean result;
	result = contacts_store_find_individual_for_id_co (self);
#line 280 "../src/contacts-store.vala"
	return result;
#line 2099 "contacts-store.c"
}

static void
___lambda8_ (Block3Data* _data3_)
{
	ContactsStore* self;
	GSourceFunc _tmp0_;
	gpointer _tmp0__target;
#line 281 "../src/contacts-store.vala"
	self = _data3_->self;
#line 282 "../src/contacts-store.vala"
	_tmp0_ = _data3_->callback;
#line 282 "../src/contacts-store.vala"
	_tmp0__target = _data3_->callback_target;
#line 282 "../src/contacts-store.vala"
	_tmp0_ (_tmp0__target);
#line 2116 "contacts-store.c"
}

static void
____lambda8__contacts_store_quiescent (ContactsStore* _sender,
                                       gpointer self)
{
#line 281 "../src/contacts-store.vala"
	___lambda8_ (self);
#line 2125 "contacts-store.c"
}

static gboolean
contacts_store_find_individual_for_id_co (ContactsStoreFindIndividualForIdData* _data_)
{
#line 276 "../src/contacts-store.vala"
	switch (_data_->_state_) {
#line 276 "../src/contacts-store.vala"
		case 0:
#line 2135 "contacts-store.c"
		goto _state_0;
#line 276 "../src/contacts-store.vala"
		case 1:
#line 2139 "contacts-store.c"
		goto _state_1;
		default:
#line 276 "../src/contacts-store.vala"
		g_assert_not_reached ();
#line 2144 "contacts-store.c"
	}
	_state_0:
#line 278 "../src/contacts-store.vala"
	_data_->_tmp0_ = _data_->self->priv->_aggregator;
#line 278 "../src/contacts-store.vala"
	_data_->_tmp1_ = folks_individual_aggregator_get_is_quiescent (_data_->_tmp0_);
#line 278 "../src/contacts-store.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 278 "../src/contacts-store.vala"
	if (!_data_->_tmp2_) {
#line 278 "../src/contacts-store.vala"
		_data_->_data3_ = g_slice_new0 (Block3Data);
#line 278 "../src/contacts-store.vala"
		_data_->_data3_->_ref_count_ = 1;
#line 278 "../src/contacts-store.vala"
		_data_->_data3_->self = g_object_ref (_data_->self);
#line 280 "../src/contacts-store.vala"
		_data_->_data3_->callback = _contacts_store_find_individual_for_id_co_gsource_func;
#line 280 "../src/contacts-store.vala"
		_data_->_data3_->callback_target = _data_;
#line 280 "../src/contacts-store.vala"
		_data_->_data3_->callback_target_destroy_notify = NULL;
#line 281 "../src/contacts-store.vala"
		_data_->_tmp3_ = g_signal_connect_data (_data_->self, "quiescent", (GCallback) ____lambda8__contacts_store_quiescent, block3_data_ref (_data_->_data3_), (GClosureNotify) block3_data_unref, 0);
#line 281 "../src/contacts-store.vala"
		_data_->signal_id = _data_->_tmp3_;
#line 284 "../src/contacts-store.vala"
		_data_->_state_ = 1;
#line 284 "../src/contacts-store.vala"
		return FALSE;
#line 2175 "contacts-store.c"
		_state_1:
		;
#line 285 "../src/contacts-store.vala"
		g_signal_handler_disconnect ((GObject*) _data_->self, _data_->signal_id);
#line 278 "../src/contacts-store.vala"
		block3_data_unref (_data_->_data3_);
#line 278 "../src/contacts-store.vala"
		_data_->_data3_ = NULL;
#line 2184 "contacts-store.c"
	}
	{
#line 288 "../src/contacts-store.vala"
		_data_->i = (guint) 0;
#line 2189 "contacts-store.c"
		{
#line 288 "../src/contacts-store.vala"
			_data_->_tmp4_ = TRUE;
#line 288 "../src/contacts-store.vala"
			while (TRUE) {
#line 288 "../src/contacts-store.vala"
				if (!_data_->_tmp4_) {
#line 288 "../src/contacts-store.vala"
					_data_->_tmp5_ = _data_->i;
#line 288 "../src/contacts-store.vala"
					_data_->i = _data_->_tmp5_ + 1;
#line 2201 "contacts-store.c"
				}
#line 288 "../src/contacts-store.vala"
				_data_->_tmp4_ = FALSE;
#line 288 "../src/contacts-store.vala"
				_data_->_tmp6_ = contacts_store_get_individuals (_data_->self);
#line 288 "../src/contacts-store.vala"
				_data_->_tmp7_ = _data_->_tmp6_;
#line 288 "../src/contacts-store.vala"
				if (!(_data_->i < g_list_model_get_n_items (_data_->_tmp7_))) {
#line 288 "../src/contacts-store.vala"
					break;
#line 2213 "contacts-store.c"
				}
#line 289 "../src/contacts-store.vala"
				_data_->_tmp8_ = contacts_store_get_individuals (_data_->self);
#line 289 "../src/contacts-store.vala"
				_data_->_tmp9_ = _data_->_tmp8_;
#line 289 "../src/contacts-store.vala"
				_data_->_tmp10_ = g_list_model_get_item (_data_->_tmp9_, _data_->i);
#line 289 "../src/contacts-store.vala"
				_data_->individual = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, FOLKS_TYPE_INDIVIDUAL, FolksIndividual);
#line 290 "../src/contacts-store.vala"
				_data_->_tmp11_ = _data_->individual;
#line 290 "../src/contacts-store.vala"
				_data_->_tmp12_ = folks_individual_get_id (_data_->_tmp11_);
#line 290 "../src/contacts-store.vala"
				_data_->_tmp13_ = _data_->_tmp12_;
#line 290 "../src/contacts-store.vala"
				if (g_strcmp0 (_data_->_tmp13_, _data_->id) == 0) {
#line 291 "../src/contacts-store.vala"
					_data_->result = _data_->i;
#line 291 "../src/contacts-store.vala"
					_g_object_unref0 (_data_->individual);
#line 291 "../src/contacts-store.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 291 "../src/contacts-store.vala"
					if (_data_->_state_ != 0) {
#line 291 "../src/contacts-store.vala"
						while (!g_task_get_completed (_data_->_async_result)) {
#line 291 "../src/contacts-store.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2243 "contacts-store.c"
						}
					}
#line 291 "../src/contacts-store.vala"
					g_object_unref (_data_->_async_result);
#line 291 "../src/contacts-store.vala"
					return FALSE;
#line 2250 "contacts-store.c"
				}
#line 288 "../src/contacts-store.vala"
				_g_object_unref0 (_data_->individual);
#line 2254 "contacts-store.c"
			}
		}
	}
#line 294 "../src/contacts-store.vala"
	_data_->result = GTK_INVALID_LIST_POSITION;
#line 294 "../src/contacts-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 294 "../src/contacts-store.vala"
	if (_data_->_state_ != 0) {
#line 294 "../src/contacts-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 294 "../src/contacts-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2268 "contacts-store.c"
		}
	}
#line 294 "../src/contacts-store.vala"
	g_object_unref (_data_->_async_result);
#line 294 "../src/contacts-store.vala"
	return FALSE;
#line 2275 "contacts-store.c"
}

/**
   * Sets the primary address book. This will be used as the primary candidate
   * to store new contacts, and will prioritize personas coming from this store
   * when showing them.
   */
void
contacts_store_set_primary_address_book (ContactsStore* self,
                                         EdsfPersonaStore* e_store)
{
	ESourceRegistry* _tmp0_;
	ESource* _tmp1_;
	ESource* _tmp2_;
	GSettings* settings = NULL;
	GSettings* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 302 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 302 "../src/contacts-store.vala"
	g_return_if_fail (e_store != NULL);
#line 303 "../src/contacts-store.vala"
	_tmp0_ = contacts_eds_source_registry;
#line 303 "../src/contacts-store.vala"
	_tmp1_ = edsf_persona_store_get_source (e_store);
#line 303 "../src/contacts-store.vala"
	_tmp2_ = _tmp1_;
#line 303 "../src/contacts-store.vala"
	e_source_registry_set_default_address_book (_tmp0_, _tmp2_);
#line 304 "../src/contacts-store.vala"
	_tmp3_ = g_settings_new ("org.freedesktop.folks");
#line 304 "../src/contacts-store.vala"
	settings = _tmp3_;
#line 305 "../src/contacts-store.vala"
	_tmp4_ = folks_persona_store_get_id ((FolksPersonaStore*) e_store);
#line 305 "../src/contacts-store.vala"
	_tmp5_ = _tmp4_;
#line 305 "../src/contacts-store.vala"
	_tmp6_ = g_strdup_printf ("eds:%s", _tmp5_);
#line 305 "../src/contacts-store.vala"
	_tmp7_ = _tmp6_;
#line 305 "../src/contacts-store.vala"
	g_settings_set_string (settings, "primary-store", _tmp7_);
#line 305 "../src/contacts-store.vala"
	_g_free0 (_tmp7_);
#line 302 "../src/contacts-store.vala"
	_g_object_unref0 (settings);
#line 2326 "contacts-store.c"
}

gboolean
contacts_store_suggest_link_to (ContactsStore* self,
                                FolksIndividual* _self_,
                                FolksIndividual* other)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 308 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 308 "../src/contacts-store.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 308 "../src/contacts-store.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 309 "../src/contacts-store.vala"
	if (contacts_store_non_linkable (self, _self_)) {
#line 309 "../src/contacts-store.vala"
		_tmp0_ = TRUE;
#line 2347 "contacts-store.c"
	} else {
#line 309 "../src/contacts-store.vala"
		_tmp0_ = contacts_store_non_linkable (self, other);
#line 2351 "contacts-store.c"
	}
#line 309 "../src/contacts-store.vala"
	if (_tmp0_) {
#line 310 "../src/contacts-store.vala"
		result = FALSE;
#line 310 "../src/contacts-store.vala"
		return result;
#line 2359 "contacts-store.c"
	}
#line 312 "../src/contacts-store.vala"
	if (!contacts_store_may_suggest_link (self, _self_, other)) {
#line 313 "../src/contacts-store.vala"
		result = FALSE;
#line 313 "../src/contacts-store.vala"
		return result;
#line 2367 "contacts-store.c"
	}
#line 317 "../src/contacts-store.vala"
	if (!contacts_utils_has_main_persona (_self_)) {
#line 317 "../src/contacts-store.vala"
		_tmp1_ = TRUE;
#line 2373 "contacts-store.c"
	} else {
#line 317 "../src/contacts-store.vala"
		_tmp1_ = !contacts_store_has_mainable_persona (self, other);
#line 2377 "contacts-store.c"
	}
#line 317 "../src/contacts-store.vala"
	result = _tmp1_;
#line 317 "../src/contacts-store.vala"
	return result;
#line 2383 "contacts-store.c"
}

static gboolean
contacts_store_has_mainable_persona (ContactsStore* self,
                                     FolksIndividual* individual)
{
	gboolean result;
#line 322 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 322 "../src/contacts-store.vala"
	g_return_val_if_fail (individual != NULL, FALSE);
#line 2395 "contacts-store.c"
	{
		GeeIterator* _p_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 323 "../src/contacts-store.vala"
		_tmp0_ = folks_individual_get_personas (individual);
#line 323 "../src/contacts-store.vala"
		_tmp1_ = _tmp0_;
#line 323 "../src/contacts-store.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 323 "../src/contacts-store.vala"
		_p_it = _tmp2_;
#line 323 "../src/contacts-store.vala"
		while (TRUE) {
#line 2411 "contacts-store.c"
			GeeIterator* _tmp3_;
			FolksPersona* p = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			gboolean _tmp6_ = FALSE;
			FolksPersona* _tmp7_;
			FolksPersonaStore* _tmp8_;
			FolksPersonaStore* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
#line 323 "../src/contacts-store.vala"
			_tmp3_ = _p_it;
#line 323 "../src/contacts-store.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 323 "../src/contacts-store.vala"
				break;
#line 2428 "contacts-store.c"
			}
#line 323 "../src/contacts-store.vala"
			_tmp4_ = _p_it;
#line 323 "../src/contacts-store.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 323 "../src/contacts-store.vala"
			p = (FolksPersona*) _tmp5_;
#line 324 "../src/contacts-store.vala"
			_tmp7_ = p;
#line 324 "../src/contacts-store.vala"
			_tmp8_ = folks_persona_get_store (_tmp7_);
#line 324 "../src/contacts-store.vala"
			_tmp9_ = _tmp8_;
#line 324 "../src/contacts-store.vala"
			_tmp10_ = folks_persona_store_get_type_id (_tmp9_);
#line 324 "../src/contacts-store.vala"
			_tmp11_ = _tmp10_;
#line 324 "../src/contacts-store.vala"
			if (g_strcmp0 (_tmp11_, "eds") == 0) {
#line 2448 "contacts-store.c"
				FolksPersona* _tmp12_;
#line 325 "../src/contacts-store.vala"
				_tmp12_ = p;
#line 325 "../src/contacts-store.vala"
				_tmp6_ = !contacts_utils_persona_is_google_other (_tmp12_);
#line 2454 "contacts-store.c"
			} else {
#line 324 "../src/contacts-store.vala"
				_tmp6_ = FALSE;
#line 2458 "contacts-store.c"
			}
#line 324 "../src/contacts-store.vala"
			if (_tmp6_) {
#line 326 "../src/contacts-store.vala"
				result = TRUE;
#line 326 "../src/contacts-store.vala"
				_g_object_unref0 (p);
#line 326 "../src/contacts-store.vala"
				_g_object_unref0 (_p_it);
#line 326 "../src/contacts-store.vala"
				return result;
#line 2470 "contacts-store.c"
			}
#line 323 "../src/contacts-store.vala"
			_g_object_unref0 (p);
#line 2474 "contacts-store.c"
		}
#line 323 "../src/contacts-store.vala"
		_g_object_unref0 (_p_it);
#line 2478 "contacts-store.c"
	}
#line 328 "../src/contacts-store.vala"
	result = FALSE;
#line 328 "../src/contacts-store.vala"
	return result;
#line 2484 "contacts-store.c"
}

static gboolean
contacts_store_non_linkable (ContactsStore* self,
                             FolksIndividual* individual)
{
	gboolean all_unlinkable = FALSE;
	gboolean result;
#line 333 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 333 "../src/contacts-store.vala"
	g_return_val_if_fail (individual != NULL, FALSE);
#line 334 "../src/contacts-store.vala"
	all_unlinkable = TRUE;
#line 2499 "contacts-store.c"
	{
		GeeIterator* _p_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 336 "../src/contacts-store.vala"
		_tmp0_ = folks_individual_get_personas (individual);
#line 336 "../src/contacts-store.vala"
		_tmp1_ = _tmp0_;
#line 336 "../src/contacts-store.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 336 "../src/contacts-store.vala"
		_p_it = _tmp2_;
#line 336 "../src/contacts-store.vala"
		while (TRUE) {
#line 2515 "contacts-store.c"
			GeeIterator* _tmp3_;
			FolksPersona* p = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			FolksPersona* _tmp6_;
#line 336 "../src/contacts-store.vala"
			_tmp3_ = _p_it;
#line 336 "../src/contacts-store.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 336 "../src/contacts-store.vala"
				break;
#line 2527 "contacts-store.c"
			}
#line 336 "../src/contacts-store.vala"
			_tmp4_ = _p_it;
#line 336 "../src/contacts-store.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 336 "../src/contacts-store.vala"
			p = (FolksPersona*) _tmp5_;
#line 337 "../src/contacts-store.vala"
			_tmp6_ = p;
#line 337 "../src/contacts-store.vala"
			if (!contacts_utils_persona_is_google_other (_tmp6_)) {
#line 338 "../src/contacts-store.vala"
				all_unlinkable = FALSE;
#line 2541 "contacts-store.c"
			}
#line 336 "../src/contacts-store.vala"
			_g_object_unref0 (p);
#line 2545 "contacts-store.c"
		}
#line 336 "../src/contacts-store.vala"
		_g_object_unref0 (_p_it);
#line 2549 "contacts-store.c"
	}
#line 341 "../src/contacts-store.vala"
	result = all_unlinkable;
#line 341 "../src/contacts-store.vala"
	return result;
#line 2555 "contacts-store.c"
}

FolksIndividualAggregator*
contacts_store_get_aggregator (ContactsStore* self)
{
	FolksIndividualAggregator* result;
	FolksIndividualAggregator* _tmp0_;
#line 40 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/contacts-store.vala"
	_tmp0_ = self->priv->_aggregator;
#line 40 "../src/contacts-store.vala"
	result = _tmp0_;
#line 40 "../src/contacts-store.vala"
	return result;
#line 2571 "contacts-store.c"
}

static void
contacts_store_set_aggregator (ContactsStore* self,
                               FolksIndividualAggregator* value)
{
	FolksIndividualAggregator* old_value;
#line 40 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/contacts-store.vala"
	old_value = contacts_store_get_aggregator (self);
#line 40 "../src/contacts-store.vala"
	if (old_value != value) {
#line 2585 "contacts-store.c"
		FolksIndividualAggregator* _tmp0_;
#line 40 "../src/contacts-store.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 40 "../src/contacts-store.vala"
		_g_object_unref0 (self->priv->_aggregator);
#line 40 "../src/contacts-store.vala"
		self->priv->_aggregator = _tmp0_;
#line 40 "../src/contacts-store.vala"
		g_object_notify_by_pspec ((GObject *) self, contacts_store_properties[CONTACTS_STORE_AGGREGATOR_PROPERTY]);
#line 2595 "contacts-store.c"
	}
}

FolksBackendStore*
contacts_store_get_backend_store (ContactsStore* self)
{
	FolksBackendStore* result;
	FolksIndividualAggregator* _tmp0_;
	FolksBackendStore* _tmp1_;
	FolksBackendStore* _tmp2_;
#line 41 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/contacts-store.vala"
	_tmp0_ = self->priv->_aggregator;
#line 41 "../src/contacts-store.vala"
	_tmp1_ = folks_individual_aggregator_get_backend_store (_tmp0_);
#line 41 "../src/contacts-store.vala"
	_tmp2_ = _tmp1_;
#line 41 "../src/contacts-store.vala"
	result = _tmp2_;
#line 41 "../src/contacts-store.vala"
	return result;
#line 2618 "contacts-store.c"
}

GListModel*
contacts_store_get_address_books (ContactsStore* self)
{
	GListModel* result;
	GListStore* _tmp0_;
#line 45 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/contacts-store.vala"
	_tmp0_ = self->priv->_address_books;
#line 45 "../src/contacts-store.vala"
	result = (GListModel*) _tmp0_;
#line 45 "../src/contacts-store.vala"
	return result;
#line 2634 "contacts-store.c"
}

ContactsIndividualSorter*
contacts_store_get_sorter (ContactsStore* self)
{
	ContactsIndividualSorter* result;
	ContactsIndividualSorter* _tmp0_;
#line 53 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/contacts-store.vala"
	_tmp0_ = self->priv->_sorter;
#line 53 "../src/contacts-store.vala"
	result = _tmp0_;
#line 53 "../src/contacts-store.vala"
	return result;
#line 2650 "contacts-store.c"
}

static void
contacts_store_set_sorter (ContactsStore* self,
                           ContactsIndividualSorter* value)
{
	ContactsIndividualSorter* old_value;
#line 53 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/contacts-store.vala"
	old_value = contacts_store_get_sorter (self);
#line 53 "../src/contacts-store.vala"
	if (old_value != value) {
#line 2664 "contacts-store.c"
		ContactsIndividualSorter* _tmp0_;
#line 53 "../src/contacts-store.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 53 "../src/contacts-store.vala"
		_g_object_unref0 (self->priv->_sorter);
#line 53 "../src/contacts-store.vala"
		self->priv->_sorter = _tmp0_;
#line 53 "../src/contacts-store.vala"
		g_object_notify_by_pspec ((GObject *) self, contacts_store_properties[CONTACTS_STORE_SORTER_PROPERTY]);
#line 2674 "contacts-store.c"
	}
}

ContactsQueryFilter*
contacts_store_get_query_filter (ContactsStore* self)
{
	ContactsQueryFilter* result;
	ContactsQueryFilter* _tmp0_;
#line 57 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../src/contacts-store.vala"
	_tmp0_ = self->priv->_query_filter;
#line 57 "../src/contacts-store.vala"
	result = _tmp0_;
#line 57 "../src/contacts-store.vala"
	return result;
#line 2691 "contacts-store.c"
}

static void
contacts_store_set_query_filter (ContactsStore* self,
                                 ContactsQueryFilter* value)
{
	ContactsQueryFilter* old_value;
#line 57 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/contacts-store.vala"
	old_value = contacts_store_get_query_filter (self);
#line 57 "../src/contacts-store.vala"
	if (old_value != value) {
#line 2705 "contacts-store.c"
		ContactsQueryFilter* _tmp0_;
#line 57 "../src/contacts-store.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 57 "../src/contacts-store.vala"
		_g_object_unref0 (self->priv->_query_filter);
#line 57 "../src/contacts-store.vala"
		self->priv->_query_filter = _tmp0_;
#line 57 "../src/contacts-store.vala"
		g_object_notify_by_pspec ((GObject *) self, contacts_store_properties[CONTACTS_STORE_QUERY_FILTER_PROPERTY]);
#line 2715 "contacts-store.c"
	}
}

ContactsManualFilter*
contacts_store_get_manual_filter (ContactsStore* self)
{
	ContactsManualFilter* result;
	ContactsManualFilter* _tmp0_;
#line 58 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../src/contacts-store.vala"
	_tmp0_ = self->priv->_manual_filter;
#line 58 "../src/contacts-store.vala"
	result = _tmp0_;
#line 58 "../src/contacts-store.vala"
	return result;
#line 2732 "contacts-store.c"
}

static void
contacts_store_set_manual_filter (ContactsStore* self,
                                  ContactsManualFilter* value)
{
	ContactsManualFilter* old_value;
#line 58 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/contacts-store.vala"
	old_value = contacts_store_get_manual_filter (self);
#line 58 "../src/contacts-store.vala"
	if (old_value != value) {
#line 2746 "contacts-store.c"
		ContactsManualFilter* _tmp0_;
#line 58 "../src/contacts-store.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 58 "../src/contacts-store.vala"
		_g_object_unref0 (self->priv->_manual_filter);
#line 58 "../src/contacts-store.vala"
		self->priv->_manual_filter = _tmp0_;
#line 58 "../src/contacts-store.vala"
		g_object_notify_by_pspec ((GObject *) self, contacts_store_properties[CONTACTS_STORE_MANUAL_FILTER_PROPERTY]);
#line 2756 "contacts-store.c"
	}
}

GListModel*
contacts_store_get_individuals (ContactsStore* self)
{
	GListModel* result;
	GtkFilterListModel* _tmp0_;
#line 62 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../src/contacts-store.vala"
	_tmp0_ = self->priv->filter_model;
#line 62 "../src/contacts-store.vala"
	result = (GListModel*) _tmp0_;
#line 62 "../src/contacts-store.vala"
	return result;
#line 2773 "contacts-store.c"
}

static void
_contacts_store___lambda9_ (ContactsStore* self,
                            FolksBackend* backend)
{
#line 146 "../src/contacts-store.vala"
	g_return_if_fail (backend != NULL);
#line 2782 "contacts-store.c"
	{
		GeeIterator* _persona_store_it = NULL;
		GeeMap* _tmp0_;
		GeeMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 147 "../src/contacts-store.vala"
		_tmp0_ = folks_backend_get_persona_stores (backend);
#line 147 "../src/contacts-store.vala"
		_tmp1_ = _tmp0_;
#line 147 "../src/contacts-store.vala"
		_tmp2_ = gee_map_get_values (_tmp1_);
#line 147 "../src/contacts-store.vala"
		_tmp3_ = _tmp2_;
#line 147 "../src/contacts-store.vala"
		_tmp4_ = _tmp3_;
#line 147 "../src/contacts-store.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 147 "../src/contacts-store.vala"
		_tmp6_ = _tmp5_;
#line 147 "../src/contacts-store.vala"
		_g_object_unref0 (_tmp4_);
#line 147 "../src/contacts-store.vala"
		_persona_store_it = _tmp6_;
#line 147 "../src/contacts-store.vala"
		while (TRUE) {
#line 2812 "contacts-store.c"
			GeeIterator* _tmp7_;
			FolksPersonaStore* persona_store = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GListStore* _tmp10_;
			FolksPersonaStore* _tmp11_;
#line 147 "../src/contacts-store.vala"
			_tmp7_ = _persona_store_it;
#line 147 "../src/contacts-store.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 147 "../src/contacts-store.vala"
				break;
#line 2825 "contacts-store.c"
			}
#line 147 "../src/contacts-store.vala"
			_tmp8_ = _persona_store_it;
#line 147 "../src/contacts-store.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 147 "../src/contacts-store.vala"
			persona_store = (FolksPersonaStore*) _tmp9_;
#line 148 "../src/contacts-store.vala"
			_tmp10_ = self->priv->_address_books;
#line 148 "../src/contacts-store.vala"
			_tmp11_ = persona_store;
#line 148 "../src/contacts-store.vala"
			g_list_store_append (_tmp10_, (GObject*) _tmp11_);
#line 147 "../src/contacts-store.vala"
			_g_object_unref0 (persona_store);
#line 2841 "contacts-store.c"
		}
#line 147 "../src/contacts-store.vala"
		_g_object_unref0 (_persona_store_it);
#line 2845 "contacts-store.c"
	}
}

static void
__contacts_store___lambda9__folks_backend_store_backend_available (FolksBackendStore* _sender,
                                                                   FolksBackend* backend,
                                                                   gpointer self)
{
#line 146 "../src/contacts-store.vala"
	_contacts_store___lambda9_ ((ContactsStore*) self, backend);
#line 2856 "contacts-store.c"
}

static gboolean
__lambda11_ (ContactsStore* self)
{
	gboolean result;
#line 156 "../src/contacts-store.vala"
	g_signal_emit (self, contacts_store_signals[CONTACTS_STORE_QUIESCENT_SIGNAL], 0);
#line 157 "../src/contacts-store.vala"
	result = FALSE;
#line 157 "../src/contacts-store.vala"
	return result;
#line 2869 "contacts-store.c"
}

static gboolean
___lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda11_ ((ContactsStore*) self);
#line 155 "../src/contacts-store.vala"
	return result;
#line 2879 "contacts-store.c"
}

static void
_contacts_store___lambda10_ (ContactsStore* self,
                             GObject* obj,
                             GParamSpec* pspec)
{
#line 153 "../src/contacts-store.vala"
	g_return_if_fail (obj != NULL);
#line 153 "../src/contacts-store.vala"
	g_return_if_fail (pspec != NULL);
#line 155 "../src/contacts-store.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda11__gsource_func, g_object_ref (self), g_object_unref);
#line 2893 "contacts-store.c"
}

static void
__contacts_store___lambda10__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
#line 153 "../src/contacts-store.vala"
	_contacts_store___lambda10_ ((ContactsStore*) self, _sender, pspec);
#line 2903 "contacts-store.c"
}

static gboolean
__lambda13_ (ContactsStore* self)
{
	gboolean result;
#line 163 "../src/contacts-store.vala"
	g_signal_emit (self, contacts_store_signals[CONTACTS_STORE_PREPARED_SIGNAL], 0);
#line 164 "../src/contacts-store.vala"
	result = FALSE;
#line 164 "../src/contacts-store.vala"
	return result;
#line 2916 "contacts-store.c"
}

static gboolean
___lambda13__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda13_ ((ContactsStore*) self);
#line 162 "../src/contacts-store.vala"
	return result;
#line 2926 "contacts-store.c"
}

static void
_contacts_store___lambda12_ (ContactsStore* self,
                             GObject* obj,
                             GParamSpec* pspec)
{
#line 161 "../src/contacts-store.vala"
	g_return_if_fail (obj != NULL);
#line 161 "../src/contacts-store.vala"
	g_return_if_fail (pspec != NULL);
#line 162 "../src/contacts-store.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda13__gsource_func, g_object_ref (self), g_object_unref);
#line 2940 "contacts-store.c"
}

static void
__contacts_store___lambda12__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
#line 161 "../src/contacts-store.vala"
	_contacts_store___lambda12_ ((ContactsStore*) self, _sender, pspec);
#line 2950 "contacts-store.c"
}

static void
_contacts_store_on_individuals_changed_detailed_folks_individual_aggregator_individuals_changed_detailed (FolksIndividualAggregator* _sender,
                                                                                                          GeeMultiMap* changes,
                                                                                                          gpointer self)
{
#line 168 "../src/contacts-store.vala"
	contacts_store_on_individuals_changed_detailed ((ContactsStore*) self, changes);
#line 2960 "contacts-store.c"
}

static GObject *
contacts_store_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ContactsStore * self;
	GeeHashMultiMap* _tmp0_;
	FolksBackendStore* backend_store = NULL;
	FolksBackendStore* _tmp1_;
	FolksBackendStore* _tmp26_;
	FolksBackendStore* _tmp27_;
	FolksIndividualAggregator* _tmp28_;
	FolksIndividualAggregator* _tmp29_;
	FolksIndividualAggregator* _tmp30_;
	FolksIndividualAggregator* _tmp31_;
	FolksIndividualAggregator* _tmp32_;
	FolksIndividualAggregator* _tmp33_;
#line 134 "../src/contacts-store.vala"
	parent_class = G_OBJECT_CLASS (contacts_store_parent_class);
#line 134 "../src/contacts-store.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 134 "../src/contacts-store.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_STORE, ContactsStore);
#line 135 "../src/contacts-store.vala"
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 135 "../src/contacts-store.vala"
	_g_object_unref0 (self->dont_suggest_link);
#line 135 "../src/contacts-store.vala"
	self->dont_suggest_link = _tmp0_;
#line 136 "../src/contacts-store.vala"
	contacts_store_read_dont_suggest_db (self);
#line 139 "../src/contacts-store.vala"
	_tmp1_ = folks_backend_store_dup ();
#line 139 "../src/contacts-store.vala"
	backend_store = _tmp1_;
#line 3000 "contacts-store.c"
	{
		GeeIterator* _backend_it = NULL;
		FolksBackendStore* _tmp2_;
		GeeMap* _tmp3_;
		GeeMap* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
		GeeIterator* _tmp8_;
		GeeIterator* _tmp9_;
#line 142 "../src/contacts-store.vala"
		_tmp2_ = backend_store;
#line 142 "../src/contacts-store.vala"
		_tmp3_ = folks_backend_store_get_enabled_backends (_tmp2_);
#line 142 "../src/contacts-store.vala"
		_tmp4_ = _tmp3_;
#line 142 "../src/contacts-store.vala"
		_tmp5_ = gee_map_get_values (_tmp4_);
#line 142 "../src/contacts-store.vala"
		_tmp6_ = _tmp5_;
#line 142 "../src/contacts-store.vala"
		_tmp7_ = _tmp6_;
#line 142 "../src/contacts-store.vala"
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 142 "../src/contacts-store.vala"
		_tmp9_ = _tmp8_;
#line 142 "../src/contacts-store.vala"
		_g_object_unref0 (_tmp7_);
#line 142 "../src/contacts-store.vala"
		_backend_it = _tmp9_;
#line 142 "../src/contacts-store.vala"
		while (TRUE) {
#line 3033 "contacts-store.c"
			GeeIterator* _tmp10_;
			FolksBackend* backend = NULL;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
#line 142 "../src/contacts-store.vala"
			_tmp10_ = _backend_it;
#line 142 "../src/contacts-store.vala"
			if (!gee_iterator_next (_tmp10_)) {
#line 142 "../src/contacts-store.vala"
				break;
#line 3044 "contacts-store.c"
			}
#line 142 "../src/contacts-store.vala"
			_tmp11_ = _backend_it;
#line 142 "../src/contacts-store.vala"
			_tmp12_ = gee_iterator_get (_tmp11_);
#line 142 "../src/contacts-store.vala"
			backend = (FolksBackend*) _tmp12_;
#line 3052 "contacts-store.c"
			{
				GeeIterator* _persona_store_it = NULL;
				FolksBackend* _tmp13_;
				GeeMap* _tmp14_;
				GeeMap* _tmp15_;
				GeeCollection* _tmp16_;
				GeeCollection* _tmp17_;
				GeeCollection* _tmp18_;
				GeeIterator* _tmp19_;
				GeeIterator* _tmp20_;
#line 143 "../src/contacts-store.vala"
				_tmp13_ = backend;
#line 143 "../src/contacts-store.vala"
				_tmp14_ = folks_backend_get_persona_stores (_tmp13_);
#line 143 "../src/contacts-store.vala"
				_tmp15_ = _tmp14_;
#line 143 "../src/contacts-store.vala"
				_tmp16_ = gee_map_get_values (_tmp15_);
#line 143 "../src/contacts-store.vala"
				_tmp17_ = _tmp16_;
#line 143 "../src/contacts-store.vala"
				_tmp18_ = _tmp17_;
#line 143 "../src/contacts-store.vala"
				_tmp19_ = gee_iterable_iterator ((GeeIterable*) _tmp18_);
#line 143 "../src/contacts-store.vala"
				_tmp20_ = _tmp19_;
#line 143 "../src/contacts-store.vala"
				_g_object_unref0 (_tmp18_);
#line 143 "../src/contacts-store.vala"
				_persona_store_it = _tmp20_;
#line 143 "../src/contacts-store.vala"
				while (TRUE) {
#line 3085 "contacts-store.c"
					GeeIterator* _tmp21_;
					FolksPersonaStore* persona_store = NULL;
					GeeIterator* _tmp22_;
					gpointer _tmp23_;
					GListStore* _tmp24_;
					FolksPersonaStore* _tmp25_;
#line 143 "../src/contacts-store.vala"
					_tmp21_ = _persona_store_it;
#line 143 "../src/contacts-store.vala"
					if (!gee_iterator_next (_tmp21_)) {
#line 143 "../src/contacts-store.vala"
						break;
#line 3098 "contacts-store.c"
					}
#line 143 "../src/contacts-store.vala"
					_tmp22_ = _persona_store_it;
#line 143 "../src/contacts-store.vala"
					_tmp23_ = gee_iterator_get (_tmp22_);
#line 143 "../src/contacts-store.vala"
					persona_store = (FolksPersonaStore*) _tmp23_;
#line 144 "../src/contacts-store.vala"
					_tmp24_ = self->priv->_address_books;
#line 144 "../src/contacts-store.vala"
					_tmp25_ = persona_store;
#line 144 "../src/contacts-store.vala"
					g_list_store_append (_tmp24_, (GObject*) _tmp25_);
#line 143 "../src/contacts-store.vala"
					_g_object_unref0 (persona_store);
#line 3114 "contacts-store.c"
				}
#line 143 "../src/contacts-store.vala"
				_g_object_unref0 (_persona_store_it);
#line 3118 "contacts-store.c"
			}
#line 142 "../src/contacts-store.vala"
			_g_object_unref0 (backend);
#line 3122 "contacts-store.c"
		}
#line 142 "../src/contacts-store.vala"
		_g_object_unref0 (_backend_it);
#line 3126 "contacts-store.c"
	}
#line 146 "../src/contacts-store.vala"
	_tmp26_ = backend_store;
#line 146 "../src/contacts-store.vala"
	g_signal_connect_object (_tmp26_, "backend-available", (GCallback) __contacts_store___lambda9__folks_backend_store_backend_available, self, 0);
#line 152 "../src/contacts-store.vala"
	_tmp27_ = backend_store;
#line 152 "../src/contacts-store.vala"
	_tmp28_ = folks_individual_aggregator_dup_with_backend_store (_tmp27_);
#line 152 "../src/contacts-store.vala"
	_tmp29_ = _tmp28_;
#line 152 "../src/contacts-store.vala"
	contacts_store_set_aggregator (self, _tmp29_);
#line 152 "../src/contacts-store.vala"
	_g_object_unref0 (_tmp29_);
#line 153 "../src/contacts-store.vala"
	_tmp30_ = self->priv->_aggregator;
#line 153 "../src/contacts-store.vala"
	g_signal_connect_object ((GObject*) _tmp30_, "notify::is-quiescent", (GCallback) __contacts_store___lambda10__g_object_notify, self, 0);
#line 161 "../src/contacts-store.vala"
	_tmp31_ = self->priv->_aggregator;
#line 161 "../src/contacts-store.vala"
	g_signal_connect_object ((GObject*) _tmp31_, "notify::is-prepared", (GCallback) __contacts_store___lambda12__g_object_notify, self, 0);
#line 168 "../src/contacts-store.vala"
	_tmp32_ = self->priv->_aggregator;
#line 168 "../src/contacts-store.vala"
	g_signal_connect_object (_tmp32_, "individuals-changed-detailed", (GCallback) _contacts_store_on_individuals_changed_detailed_folks_individual_aggregator_individuals_changed_detailed, self, 0);
#line 169 "../src/contacts-store.vala"
	_tmp33_ = self->priv->_aggregator;
#line 169 "../src/contacts-store.vala"
	folks_individual_aggregator_prepare (_tmp33_, NULL, NULL);
#line 134 "../src/contacts-store.vala"
	_g_object_unref0 (backend_store);
#line 134 "../src/contacts-store.vala"
	return obj;
#line 3162 "contacts-store.c"
}

static void
contacts_store_class_init (ContactsStoreClass * klass,
                           gpointer klass_data)
{
#line 35 "../src/contacts-store.vala"
	contacts_store_parent_class = g_type_class_peek_parent (klass);
#line 35 "../src/contacts-store.vala"
	g_type_class_adjust_private_offset (klass, &ContactsStore_private_offset);
#line 35 "../src/contacts-store.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_contacts_store_get_property;
#line 35 "../src/contacts-store.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_contacts_store_set_property;
#line 35 "../src/contacts-store.vala"
	G_OBJECT_CLASS (klass)->constructor = contacts_store_constructor;
#line 35 "../src/contacts-store.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_store_finalize;
#line 35 "../src/contacts-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_AGGREGATOR_PROPERTY, contacts_store_properties[CONTACTS_STORE_AGGREGATOR_PROPERTY] = g_param_spec_object ("aggregator", "aggregator", "aggregator", FOLKS_TYPE_INDIVIDUAL_AGGREGATOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/contacts-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_BACKEND_STORE_PROPERTY, contacts_store_properties[CONTACTS_STORE_BACKEND_STORE_PROPERTY] = g_param_spec_object ("backend-store", "backend-store", "backend-store", FOLKS_TYPE_BACKEND_STORE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/contacts-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_ADDRESS_BOOKS_PROPERTY, contacts_store_properties[CONTACTS_STORE_ADDRESS_BOOKS_PROPERTY] = g_param_spec_object ("address-books", "address-books", "address-books", g_list_model_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/contacts-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_SORTER_PROPERTY, contacts_store_properties[CONTACTS_STORE_SORTER_PROPERTY] = g_param_spec_object ("sorter", "sorter", "sorter", CONTACTS_TYPE_INDIVIDUAL_SORTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/contacts-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_QUERY_FILTER_PROPERTY, contacts_store_properties[CONTACTS_STORE_QUERY_FILTER_PROPERTY] = g_param_spec_object ("query-filter", "query-filter", "query-filter", CONTACTS_TYPE_QUERY_FILTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/contacts-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_MANUAL_FILTER_PROPERTY, contacts_store_properties[CONTACTS_STORE_MANUAL_FILTER_PROPERTY] = g_param_spec_object ("manual-filter", "manual-filter", "manual-filter", CONTACTS_TYPE_MANUAL_FILTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3193 "contacts-store.c"
	/** The list of individuals after all sorting/filtering operations */
#line 35 "../src/contacts-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_INDIVIDUALS_PROPERTY, contacts_store_properties[CONTACTS_STORE_INDIVIDUALS_PROPERTY] = g_param_spec_object ("individuals", "individuals", "individuals", g_list_model_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/contacts-store.vala"
	contacts_store_signals[CONTACTS_STORE_QUIESCENT_SIGNAL] = g_signal_new ("quiescent", CONTACTS_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/contacts-store.vala"
	contacts_store_signals[CONTACTS_STORE_PREPARED_SIGNAL] = g_signal_new ("prepared", CONTACTS_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3201 "contacts-store.c"
}

static void
contacts_store_instance_init (ContactsStore * self,
                              gpointer klass)
{
	GListStore* _tmp0_;
	GListStore* _tmp1_;
#line 35 "../src/contacts-store.vala"
	self->priv = contacts_store_get_instance_private (self);
#line 43 "../src/contacts-store.vala"
	_tmp0_ = g_list_store_new (FOLKS_TYPE_PERSONA_STORE);
#line 43 "../src/contacts-store.vala"
	self->priv->_address_books = _tmp0_;
#line 49 "../src/contacts-store.vala"
	_tmp1_ = g_list_store_new (FOLKS_TYPE_INDIVIDUAL);
#line 49 "../src/contacts-store.vala"
	self->priv->base_model = _tmp1_;
#line 3220 "contacts-store.c"
}

static void
contacts_store_finalize (GObject * obj)
{
	ContactsStore * self;
#line 35 "../src/contacts-store.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_STORE, ContactsStore);
#line 40 "../src/contacts-store.vala"
	_g_object_unref0 (self->priv->_aggregator);
#line 43 "../src/contacts-store.vala"
	_g_object_unref0 (self->priv->_address_books);
#line 49 "../src/contacts-store.vala"
	_g_object_unref0 (self->priv->base_model);
#line 52 "../src/contacts-store.vala"
	_g_object_unref0 (self->priv->sort_model);
#line 53 "../src/contacts-store.vala"
	_g_object_unref0 (self->priv->_sorter);
#line 56 "../src/contacts-store.vala"
	_g_object_unref0 (self->priv->filter_model);
#line 57 "../src/contacts-store.vala"
	_g_object_unref0 (self->priv->_query_filter);
#line 58 "../src/contacts-store.vala"
	_g_object_unref0 (self->priv->_manual_filter);
#line 65 "../src/contacts-store.vala"
	_g_object_unref0 (self->dont_suggest_link);
#line 35 "../src/contacts-store.vala"
	G_OBJECT_CLASS (contacts_store_parent_class)->finalize (obj);
#line 3249 "contacts-store.c"
}

/**
 * The Contacts.Store is the base abstraction that holds all contacts (i.e.
 * {@link Folks.Indidivual}s). Note that it also has a "quiescent" and
 * "prepared" signal, with similar effects to those of a
 * {@link Folks.IndividualAggregator}.
 *
 * Internally, the Store works with 3 list models layered on top of each other:
 *
 * - A base list model which contains all contacts in the
 *   {@link Folks.IndividualAggregator}
 * - A {@link Gtk.SortListModel}, which sorts the base model according to
 *   first name or last name, or whatever user preference
 * - A {@link Gtk.FilterListModel} to filter out contacts using a
 *   {@link Folks.Query}, so a user can filter contacts with the search entry
 */
 G_GNUC_NO_INLINE static GType
contacts_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContactsStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsStore), 0, (GInstanceInitFunc) contacts_store_instance_init, NULL };
	GType contacts_store_type_id;
	contacts_store_type_id = g_type_register_static (G_TYPE_OBJECT, "ContactsStore", &g_define_type_info, 0);
	ContactsStore_private_offset = g_type_add_instance_private (contacts_store_type_id, sizeof (ContactsStorePrivate));
	return contacts_store_type_id;
}

GType
contacts_store_get_type (void)
{
	static volatile gsize contacts_store_type_id__once = 0;
	if (g_once_init_enter (&contacts_store_type_id__once)) {
		GType contacts_store_type_id;
		contacts_store_type_id = contacts_store_get_type_once ();
		g_once_init_leave (&contacts_store_type_id__once, contacts_store_type_id);
	}
	return contacts_store_type_id__once;
}

static void
_vala_contacts_store_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	ContactsStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_STORE, ContactsStore);
#line 35 "../src/contacts-store.vala"
	switch (property_id) {
#line 35 "../src/contacts-store.vala"
		case CONTACTS_STORE_AGGREGATOR_PROPERTY:
#line 35 "../src/contacts-store.vala"
		g_value_set_object (value, contacts_store_get_aggregator (self));
#line 35 "../src/contacts-store.vala"
		break;
#line 35 "../src/contacts-store.vala"
		case CONTACTS_STORE_BACKEND_STORE_PROPERTY:
#line 35 "../src/contacts-store.vala"
		g_value_set_object (value, contacts_store_get_backend_store (self));
#line 35 "../src/contacts-store.vala"
		break;
#line 35 "../src/contacts-store.vala"
		case CONTACTS_STORE_ADDRESS_BOOKS_PROPERTY:
#line 35 "../src/contacts-store.vala"
		g_value_set_object (value, contacts_store_get_address_books (self));
#line 35 "../src/contacts-store.vala"
		break;
#line 35 "../src/contacts-store.vala"
		case CONTACTS_STORE_SORTER_PROPERTY:
#line 35 "../src/contacts-store.vala"
		g_value_set_object (value, contacts_store_get_sorter (self));
#line 35 "../src/contacts-store.vala"
		break;
#line 35 "../src/contacts-store.vala"
		case CONTACTS_STORE_QUERY_FILTER_PROPERTY:
#line 35 "../src/contacts-store.vala"
		g_value_set_object (value, contacts_store_get_query_filter (self));
#line 35 "../src/contacts-store.vala"
		break;
#line 35 "../src/contacts-store.vala"
		case CONTACTS_STORE_MANUAL_FILTER_PROPERTY:
#line 35 "../src/contacts-store.vala"
		g_value_set_object (value, contacts_store_get_manual_filter (self));
#line 35 "../src/contacts-store.vala"
		break;
#line 35 "../src/contacts-store.vala"
		case CONTACTS_STORE_INDIVIDUALS_PROPERTY:
#line 35 "../src/contacts-store.vala"
		g_value_set_object (value, contacts_store_get_individuals (self));
#line 35 "../src/contacts-store.vala"
		break;
#line 3341 "contacts-store.c"
		default:
#line 35 "../src/contacts-store.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/contacts-store.vala"
		break;
#line 3347 "contacts-store.c"
	}
}

static void
_vala_contacts_store_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	ContactsStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_STORE, ContactsStore);
#line 35 "../src/contacts-store.vala"
	switch (property_id) {
#line 35 "../src/contacts-store.vala"
		case CONTACTS_STORE_AGGREGATOR_PROPERTY:
#line 35 "../src/contacts-store.vala"
		contacts_store_set_aggregator (self, g_value_get_object (value));
#line 35 "../src/contacts-store.vala"
		break;
#line 35 "../src/contacts-store.vala"
		case CONTACTS_STORE_SORTER_PROPERTY:
#line 35 "../src/contacts-store.vala"
		contacts_store_set_sorter (self, g_value_get_object (value));
#line 35 "../src/contacts-store.vala"
		break;
#line 35 "../src/contacts-store.vala"
		case CONTACTS_STORE_QUERY_FILTER_PROPERTY:
#line 35 "../src/contacts-store.vala"
		contacts_store_set_query_filter (self, g_value_get_object (value));
#line 35 "../src/contacts-store.vala"
		break;
#line 35 "../src/contacts-store.vala"
		case CONTACTS_STORE_MANUAL_FILTER_PROPERTY:
#line 35 "../src/contacts-store.vala"
		contacts_store_set_manual_filter (self, g_value_get_object (value));
#line 35 "../src/contacts-store.vala"
		break;
#line 3385 "contacts-store.c"
		default:
#line 35 "../src/contacts-store.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/contacts-store.vala"
		break;
#line 3391 "contacts-store.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

